local CC = ChrispyChars

local ScriptLoaded = false


local BUTTONS = {BT_JUMP, BT_USE, BT_TOSSFLAG, BT_CUSTOM1, BT_CUSTOM2, BT_CUSTOM3,
	BT_ATTACK, BT_FIRENORMAL, BT_WEAPONNEXT, BT_WEAPONPREV}

local CURVDASHTIME = 21
local TWIRLWINDTIME = TICRATE * 2/5
local MAXTWTIME = 21 //you stupid

--FixedLerp
local function FixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

local function ChecknBust(mo, sec, spinbust)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    if (fof.flags & FF_STRONGBUST) and (spinbust == true) continue end -- Is it too strong?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

   if (mo.player) and (mo.player.speed < mo.player.runspeed/3) continue end

    EV_CrumbleChain(fof) -- Crumble
  end
end

local function CheckAndCrumble2(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end


local RailType = function(mo, rail)
 if rail and rail.valid
  local LOOP = GS_RAILS.LearnLoopType(rail)
   local returnvalue = 0 //default

   if mo and mo.valid and (mo.state == S_PLAY_RIDE or rail.GShangrail and (P_MobjFlip(mo) == 1))
    returnvalue = 1 //hangrail
   end

  if LOOP and LOOP.walljump
    returnvalue = 2 --There you go. You now know you're on a walljump rail.
   end
  return returnvalue
 else
  return nil
 end
end

freeslot("S_PHOENIX_FLUTTER", "S_PLAY_LEVELFINISH", "S_PLAY_LEVELFINISHREPEAT",
"S_PHOENIX_YAY", "S_PHOENIX_HUMMINGTOP", "S_PLAY_BACKSPIN", "S_PHOENIX_LOOKUP", 
"S_PHOENIX_SOMERSAULT", "S_PHOENIX_SAULTJUMP_A", "S_PHOENIX_SAULTJUMP_B", "SPR2_PSFA", "SPR2_PSFB",
"S_PHOENIX_SOMERSAULT2", "S_PHOENIX_ERGRIND", "S_PHOENIX_CROUCHGRIND", "SPR2_SACG", "SPR2_GRND", "SPR2_GOKU")

spr2defaults[SPR2_PSFA] = SPR2_ROLL
spr2defaults[SPR2_PSFB] = SPR2_SPIN
spr2defaults[SPR2_SACG] = SPR2_SKID //GRND
spr2defaults[SPR2_GOKU] = SPR2_STND

states[S_PHOENIX_FLUTTER] = {
		sprite = SPR_PLAY,
		frame = SPR2_FLY_,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_PHOENIX_FLUTTER
}

states[S_PHOENIX_YAY] = {
		sprite = SPR_PLAY,
		frame = SPR2_FIRE,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_YAY
}

states[S_PHOENIX_HUMMINGTOP] = {
		sprite = SPR_PLAY,
		frame = SPR2_FRUN,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_PHOENIX_HUMMINGTOP
}

states[S_PLAY_LEVELFINISH] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_TAL2,
		var1 = S_PLAY_LEVELFINISHREPEAT,
		var2 = 0,
		tics = 3,
		nextstate = S_PLAY_LEVELFINISH
}

states[S_PLAY_LEVELFINISHREPEAT] = {
		sprite = SPR_PLAY,
		frame = SPR2_TAL3,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_PLAY_LEVELFINISHREPEAT
}

states[S_PHOENIX_LOOKUP] = {
		sprite = SPR_PLAY,
		frame = SPR2_WAIT,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_PLAY_STND
}

states[S_PHOENIX_SOMERSAULT] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_MLEE|A,
		var1 = S_PLAY_ROLL,
		var2 = 0,
		tics = 3,
		nextstate = S_PHOENIX_SOMERSAULT
}

states[S_PHOENIX_SAULTJUMP_A] = { 
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_PSFA|A,
		var1 = S_PHOENIX_SAULTJUMP_B,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_SAULTJUMP_A
}

states[S_PHOENIX_SAULTJUMP_B] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_PSFB|A,
		var1 = S_PLAY_FALL,
		var2 = 0,
		tics = 3,
		nextstate = S_PHOENIX_SAULTJUMP_B
}

states[S_PHOENIX_SOMERSAULT2] = {
		sprite = SPR_PLAY,
		frame = SPR2_ROLL,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_PLAY_ROLL
}

states[S_PHOENIX_ERGRIND] = {
		sprite = SPR_PLAY,
		frame = SPR2_SACG,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_PHOENIX_ERGRIND
}

states[S_PHOENIX_CROUCHGRIND] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2SUPER|SPR2_SACG,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_CROUCHGRIND
}


freeslot("sfx_pwhos1", "sfx_pwhos2", "sfx_pjump2")
sfxinfo[sfx_pwhos1].caption = "Whoosh"
sfxinfo[sfx_pwhos2].caption = "Woosh but 2"
sfxinfo[sfx_pjump2].caption = "Jump"


if not CC_TrickSkins 
	rawset(_G, "CC_TrickSkins", {})
end
CC_TrickSkins["phoenix"] = { // Tricks support
	alwaysenabled = false,
	bouncetricks = true,
	nosupertricks = false,
	{
		sprite2 = SPR2_GLID,
		tics = 2,
		frames = 1,
	},
	{
		sprite2 = SPR2_WALK,
		rotation = 0,
		tics = 4,
		frames = 4,
	},
	{
		sprite2 = SPR2_GASP,
		tics = 0,
		rotation = 0,
	},
	{
		sprite2 = SPR2_EDGE,
		tics = 0,
		rotation = 0,
	},
	{
		sprite2 = SPR2_RIDE,
		rotation = 1,
		tics = 0,
	},
	{
		sprite2 = SPR2_SPIN,
		rotation = 0,
		tics = 0,
	},
	{
		sprite2 = SPR2_STUN,
		rotation = 0,
		tics = 2,
	}
}

if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

PlayerAnimInfo["phoenix"] = {
		["runFrames"] = {0, 2},
		["dashFrames"] = {1, 3},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {0, 2},
		["milnekickFrames"] = {0, 4},
		["run"] = true,
		["dash"] = true,
		["walk"] = true,
		["idle"] = false,
		["wait"] = false,
		["milnekick"] = true,
		["superRun"] = true,
		["superDash"] = false,
		["superWalk"] = true,
		["superIdle"] = false,
		["superWait"] = true
}

if not(kirbyabilitytable)
    rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["phoenix"] = 5

local SKIN = "phoenix" -- Your character's skin name goes here.

addHook("PlayerSpawn", function(player)
if not (player.mo and player.mo.valid)
 return
end

end)

addHook("MapLoad", function(S0)
	if OLDC ~= nil
		if OLDC.SkinFullNames[SKIN] ~= nil then return end
		OLDC.SetSkinFullName(SKIN, "Phoenix the Enclourian")
	else
		return
	end
end)

local SKIN = "phoenix"


addHook("ShieldSpecial", function(player)
	if (player.mo and player.mo.valid)
	and player.mo.skin == SKIN
		if player.mo.state == S_PHOENIX_HUMMINGTOP then return true end
		
		
	else
		return
	end
end)

local WaterFactor = function(mo, val, dir)
 if mo and mo.valid
  local water = 0
  local water2 = 0
  
  if dir == nil or dir == 0 //vertical factor
   water = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 2 or 1
   water2 = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 3 or 1
  elseif dir == 1 //horizontal factor
   water = 1
   water2 = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 2 or 1
  end
  
  local rval = (water*val)/water2
  return rval
 else
  return
 end
end


/*addHook("MobjThinker", function(insta)
	if not (insta and insta.valid) return end
	if (insta.target)
		if (insta.target.state ~= S_PLAY_TWINSPIN and insta.target.state ~= S_PLAY_ROLL)
			insta.target.ISoccur = false
			if insta.flash
				insta.target.colorized = false
			end
			pcall(P_RemoveMobj, insta)
			return
		end
		insta.target.player.powers[pw_strong] = STR_ANIM|STR_GUARD
		insta.target.ISoccur = true
		if insta.flash
			if (insta.sprite == SPR_NULL)
				insta.target.colorized = false
			else
				insta.target.colorized = true
				insta.angle = insta.target.player.drawangle
				insta.target.frame = ($ & FF_FRAMEMASK)|FF_FULLBRIGHT
			end
			insta.angle = insta.target.player.drawangle
		end
	else
		return
	end
end, MT_PINSTASHIELD)

addHook("ShouldDamage", function(sonic, inflictor, source, damage, element)
	if (sonic.tracer) and sonic.tracer.type == MT_PINSTASHIELD
		if not (element & DMG_DEATHMASK)
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(insta, mobj)
	if not (insta.z-FixedMul(24*FRACUNIT, insta.scale) > mobj.z+mobj.height) and not(mobj.z-FixedMul(24*FRACUNIT, insta.scale) > insta.z+insta.height)
		if (mobj.valid and (mobj.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) or (mobj.flags & MF_PUSHABLE and mobj.flags & MF_SHOOTABLE))) and not (mobj.flags2 & MF2_FRET)
			P_DamageMobj(mobj, insta, insta.target)
			if P_MobjFlip(insta.target)*insta.target.momz < 0
				insta.target.momz = -$
			end
			if (mobj.info.spawnhealth > 1)
				insta.target.momy = -$
				insta.target.momx = -$
			end
		end
	end
end, MT_PINSTASHIELD)*/


local PHOENIX_DROPDASH  = S_PLAY_SPINDASH
local PHOENIX_DASH = S_PLAY_SPINDASH
local PHOENIX_LONGJUMP = S_PHOENIX_HUMMINGTOP
local PHOENIX_SUPERJUMP = S_PHOENIX_YAY
local PHOENIX_BATTERYD1 = S_PLAY_MELEE
local PHOENIX_BATTERYD2 = S_PLAY_MELEE_FINISH
local PHOENIX_SLIDE = S_PLAY_GLIDE


local YADSPEED = 72*FRACUNIT //sppeeed!!!!


local LongJump = function(mo, speed, height)
	P_SetObjectMomZ(mo, height)
	P_InstaThrust(mo, mo.angle, max(speed, mo.player.speed + speed/5))
	mo.player.pflags = $|PF_STARTJUMP|PF_JUMPED & ~(PF_SPINNING|PF_THOKKED)
	mo.state = PHOENIX_LONGJUMP
	S_StartSound(mo, sfx_zoom)
	return
end

addHook("JumpSpecial", function(player)
	if player.mo and player.mo.valid
	and player.mo.skin == SKIN
	
		if (player.pflags&PF_JUMPDOWN) then return end
	
	
		if player.dschargestate ~= nil and player.dschargestate == 1 and not (player.pflags&PF_JUMPED) and not (player.powers[pw_carry]) or (player.pflags&PF_STARTDASH)
			/*LongJump(player.mo, 40*FRACUNIT, 15/2*FRACUNIT)
			P_MovePlayer(player)
			S_StopSound(player.mo)
			S_StartSound(player.mo, sfx_zoom)
			player.pflags = $|PF_STARTJUMP|PF_JUMPED & ~(PF_SPINNING|PF_THOKKED)
			player.mo.state = PHOENIX_LONGJUMP
			player.dschargestate = 0
			player.dscharge = 0*/
	 
			S_StopSoundByID(player.mo, sfx_monton)
			return true
		end
	else
		return
	end
end)

/*addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid)
	and player.mo.skin == SKIN
		local mo = player.mo
		local cmd = player.cmd
		local skinvar = skins[player.mo.skin]
		
		if (player.pflags&PF_JUMPDOWN) then return true end
		
		if not (player.pflags&(PF_THOKKED)) and player.charability == CA_DOUBLEJUMP
			player.powers[pw_strong] = STR_ANIM|STR_STOMP|STR_CEILING|STR_PUNCH|STR_TAIL
			//P_SetObjectMomZ(mo, mo.momz*P_MobjFlip(mo) + 6*FRACUNIT)
	
			//P_SpawnThokMobj(player)
			S_StartSound(mo, sfx_s3kc6s)
			S_StartSound(mo, sfx_wdjump)
			S_StartSound(mo, sfx_s3ka0)
			//S_StartSound(player.mo, sfx_kc55)
			//S_StartSound(player.mo, sfx_cdfm66)
			
			player.backflip = false
			player.backflippin = false
			mo.state = S_PHOENIX_FLUTTER
			player.twirlwindstate = 3
			player.twtime = TWIRLWINDTIME
			player.pflags = $|PF_THOKKED & ~PF_STARTJUMP
	
			/*return true
		elseif (player.pflags&PF_SPINNING) 
			if player.dashcount < 1
				player.mo.state = S_PLAY_ROLL
				player.mo.momz = -$ * (6/6)
				P_SetObjectMomZ(mo, 7*FRACUNIT)
				P_Thrust(player.mo, player.mo.angle, FRACUNIT*5)
				player.dashcount = ($ ~= nil) and $ + 1 or 1
				S_StartSound(player.mo, sfx_s3ka6)
				P_SpawnThokMobj(player)
				
				for i = 1, 10 do //yo mama
					local dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
					P_Thrust(dust, player.mo.angle + (ANG1 * 36 * i), player.mo.scale * -20)
					P_SetObjectMomZ(dust, 5*FRACUNIT/3, true)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						dust.z = player.mo.z + player.mo.height - dust.height
					end
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
						dust.state = S_SPINDUST_BUBBLE1
					elseif player.powers[pw_shield] == SH_FLAMEAURA
						dust.state = S_SPINDUST_FIRE1
					end
				end
			end
			return true
		end
	else
		return
	end
end)






addHook("JumpSpecial", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == SKIN
		if (player.pflags&PF_JUMPDOWN) return end
		if ((player.pflags&PF_JUMPED) and not player.dsp_batterydashst and not player.homingdash and not (player.dschargestate == 3 and player.dontdothemove <= 2)) return end
  
  
  
		if (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL
		or player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_MID_FALL
		//or player.mo.state == S_PHOENIX_SA2BOUNCE
		or player.homingdash or player.mo.state == S_PLAY_TWINSPIN and player.dschargestate == 3)
		and player.gotflag == 0 and not (player.pflags&PF_SHIELDABILITY) 
		and not P_IsObjectOnGround(player.mo)
		and not ((player.pflags&PF_THOKKED) and not player.dsp_batterydashst and player.dschargestate ~= 3) //and player.hassprung
		and not player.exiting and not (player.powers[pw_carry]) and not (player.mo.eflags&MFE_UNDERWATER)
			//player.dsptwirl = false
			//player.dsptwirl_ang = 0

			player.biggerbounce = true
			player.dsp_batterydashst = 0 //bounce cancel
			player.normalspeed = skins[player.mo.skin].normalspeed
			player.powers[pw_strong] = STR_NONE
			player.dschargestate = 2
			player.dontdothemove = 3
			
			player.flutterfactor = 21
			player.mo.momz = $/5
			P_SetObjectMomZ(player.mo, max(WaterFactor(player.mo, FRACUNIT*10) + player.mo.momz*P_MobjFlip(player.mo), -player.mo.momz*P_MobjFlip(player.mo)*4), false)
			P_InstaThrust(player.mo, player.mo.angle, max(player.speed, WaterFactor(player.mo, 40*FRACUNIT, 1)))
			player.mo.state = S_PHOENIX_HUMMINGTOP
			player.panim = PA_ABILITY
			P_SpawnThokMobj(player)
			S_StartSound(player.mo, sfx_zoom)
			S_StopSoundByID(player.mo, sfx_spndsh)
			S_StartSound(player.mo, sfx_s3k45)
			   //S_StartSound(player.mo, sfx_airdsh)
			   
			P_StartQuake(FRACUNIT*10, 5)
			player.pflags = (player.pflags&PF_JUMPED) and $|PF_SPINNING|PF_JUMPED|PF_JUMPDOWN or $|PF_SPINNING|PF_JUMPED|PF_JUMPDOWN & ~PF_THOKKED
			player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPRING|STR_WALL|STR_FLOOR
			/*player.mo.state = PHOENIX_LONGJUMP
			player.pflags = $|PF_SPINNING|PF_THOKKED|PF_JUMPED
			player.scharge = 1
			player.chargedelay = TICRATE
			//P_InstaThrust(player.mo, player.mo.angle, max(player.speed + 4*FRACUNIT, 6*FRACUNIT))
			S_StartSound(player.mo, sfx_s3kab)*
			return true
		end




		if (player.dschargestate ~= nil) and player.dschargestate == 3 and not (player.pflags&PF_JUMPED) or (player.skidtime or player.mo.state == S_PLAY_SKID) and not (player.pflags&PF_JUMPED) and player.dschargestate ~= 1
			if player.isxmomentum
				player.fakenormalspeed = 36*FRACUNIT
			else
				player.normalspeed = 36*FRACUNIT
			end
			
			P_SetObjectMomZ(player.mo, 9*FRACUNIT + player.dscharge*FRACUNIT * 4/5)
			player.pflags = $|PF_JUMPED|PF_STARTJUMP & ~(PF_THOKKED|PF_SPINNING)
			
			
			if player.dscharge < 2 //and player.mo.state ~= S_PHOENIX_SOMERSAULT
				local ang = (player.dscharge ~= 1) and player.mo.angle or player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
				
				P_InstaThrust(player.mo, ang, max(FRACUNIT*16, player.speed))
				player.drawangle = ang
				P_DoJump(player, false)
			end
			
			
			if player.dscharge
				S_StopSound(player.mo)
				
				P_StartQuake(FRACUNIT*9, max(player.dscharge - 3, 0))
				P_DoJump(player, false)
				
				player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
				player.mo.state = S_PHOENIX_SAULTJUMP_A
				player.mo.frame = $ & ~FF_FRAMEMASK
				//S_StartSound(player.mo, sfx_s3ka2)
				
				if player.dscharge > 5
					local vfxhopefully = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK) //big woosh
					vfxhopefully.color = player.skincolor or player.mo.color
					vfxhopefully.fuse = TICRATE
					vfxhopefully.tics = TICRATE
					vfxhopefully.scale = player.mo.scale
					vfxhopefully.destscale = FixedMul(player.mo.scale, max(player.dscharge*FRACUNIT/2, FRACUNIT))
					S_StartSound(player.mo, sfx_s3k45)
				end
				
				
				local expandghost = P_SpawnGhostMobj(player.mo)
				expandghost.sprite2 = SPR2_LAND
				expandghost.frame = 0
				expandghost.fuse = TICRATE
				expandghost.eflags = $|MFE_FORCESUPER
				expandghost.scale = player.mo.scale
				expandghost.destscale = FixedMul(FRACUNIT*3/2, player.mo.scale)
			else
				P_DoJump(player, false)
				
				player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
				player.mo.state = S_PHOENIX_SAULTJUMP_A
				player.mo.frame = $ & ~FF_FRAMEMASK
			end
			
			
			S_StartSound(player.mo, sfx_pjump2)
			S_StartSoundAtVolume(player.mo, sfx_pwhos2, 50)
			S_StartSound(player.mo, sfx_zoom)
			
			player.dscharge = 0
			player.dschargestate = (player.dschargestate ~= 2) and 0 or $
			return true
		end
	else
		return
	end
end)



addHook("SpinSpecial", function(player)
 if (player.mo and player.mo.valid)
 and player.mo.skin == SKIN
 and not player.exiting
   
  /*if (player.mo.state == S_PLAY_GLIDE_LANDING or player.mo.state == S_PLAY_STND and player.speed <= FRACUNIT) and (player.pflags&PF_SPINDOWN)
   player.mo.state = S_PLAY_GLIDE_LANDING
   player.pflags = $|PF_STASIS & ~(PF_STARTDASH|PF_SPINNING)
   return true
  end

  if (player.pflags&PF_SPINDOWN) then return end

  if P_IsObjectOnGround(player.mo) and player.scharge == 0 and player.gotflag == 0 and (player.batterydsh_state == 1 or (player.pflags&PF_SPINNING))
			player.mo.state = PHOENIX_DASH
			player.pflags = $|PF_SPINNING
			player.scharge = 1
			player.chargedelay = TICRATE
			if player.speed <= player.runspeed
			P_InstaThrust(player.mo, player.mo.angle, max(player.speed + 4*FRACUNIT, 6*FRACUNIT))
			end
			S_StartSound(player.mo, sfx_s3kab)
			return true
		end

		if player.scharge > 0 and player.chargedelay < TICRATE*3/2 - 1
			if player.scharge < 15
				player.scharge = $ + 1
				//P_Thrust(player.mo, player.mo.angle, FRACUNIT*2)
			end

			player.chargedelay = min(TICRATE*3/2, $ + TICRATE/3)
			S_StopSound(player.mo)
			S_StartSound(player.mo, sfx_s3kab + player.scharge)
     player.mo.state = S_PLAY_SPINDASH
			return true
		end

  
   /*if player.spinslashstate == 2 and P_IsObjectOnGround(player.mo)
   player.spinslashstate = 0
   P_InstaThrust(player.mo, player.mo.angle, max(player.speed, 8*FRACUNIT))
   //P_SetObjectMomZ(player.mo, 5*FRACUNIT)
   player.mo.state = S_PHOENIX_SLIDE
   player.pflags = $|PF_SPINNING|PF_THOKKED & ~(PF_STASIS)
   player.powers[pw_strong] = STR_NONE
   S_StartSound(player.mo, sfx_spin)

   //print("spinner")
   return true
  end
  
  if not (player.mo.eflags&MFE_JUSTHITFLOOR) return end
 
  if player.spinslashstate == 0 and P_IsObjectOnGround(player.mo) //and not (player.pflags&PF_SPINNING)
   player.spinslashstate = 1
   player.mo.state = S_PLAY_DASH
   P_InstaThrust(player.mo, player.mo.angle, max(player.speed, player.mindash))
   S_StartSound(player.mo, sfx_spndsh)
   player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)

   //print("ready")
   return true
  end
  
  
  
  if P_IsObjectOnGround(player.mo) and not (player.pflags&PF_SPINNING) and player.batterydsh_state == 0 //and not (player.pflags&PF_SPINDOWN)
   player.batterydsh_state = 1
	player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPIKE
   player.mo.state = PHOENIX_BATTERYD1
   S_StartSound(player.mo, sfx_s3k42)
   return true
  end*
  
  if player.dspchargestate == 2 or (player.charability2 ~= CA2_SPINDASH) or player.yetanother_walljump
   return true
  end
  

  if not (player.pflags&PF_SPINDOWN) and player.dschargestate == 0 and not player.mun_starthold
  and not ((player.pflags&PF_SPINNING) and not (player.pflags&PF_JUMPED)) and not player.homingdash
  and (not P_IsObjectOnGround(player.mo) or P_IsObjectOnGround(player.mo) or player.powers[pw_carry])
  and not player.dsp_batterydashst ~= 3 and (player.playerstate == PST_LIVE) and not P_PlayerInPain(player)
  and not player.exiting and (player.powers[pw_carry] ~= 8 and player.powers[pw_carry] ~= 6 and player.powers[pw_carry] ~= 2
  and player.powers[pw_carry] ~= 11 and player.powers[pw_carry] ~= 3 and player.powers[pw_carry] ~= 12 and player.powers[pw_carry] ~= 7)
  and not player.dontdothemove
   player.dschargestate = 1
   player.dontdothemove = ($ == nil) and 0 or $

   if not (player.powers[pw_carry])
   player.mo.state = S_PLAY_STND
   
	player.powers[pw_strong] = STR_ANIM|STR_ATTACK
   /*if player.pflags & PF_SHIELDABILITY
    player.dontdothemove = 1
   end*
    player.prevmom = 0
    if (player.powers[pw_shield] & SH_FORCE) and not (player.dontdothemove) and not CBW_Battle and not (player.gotflag)
     player.prevmom = player.speed
     player.mo.momx = 0
     player.mo.momy = 0
     player.mo.momz = $/2
    end

   // S_StartSound(player.mo, sfx_monton)
	
	/*if player.speed <= FRACUNIT*5
   P_Thrust(player.mo, player.mo.angle, FRACUNIT*6)
	P_MovePlayer(player)
   end*
	
	player.pflags = $ & ~(PF_SPINNING)
   if (player.pflags & PF_JUMPED)
    player.pflags = $ | PF_THOKKED
   end
   end
   return true
  end

  if not (player.pflags&PF_SPINDOWN) and player.dschargestate == 3 and not (player.pflags&PF_JUMPED) //or P_IsObjectOnGround(player.mo)
   if player.dscharge < 15
   player.dscharge = $ + 1
   end
   
   local ang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
   P_Thrust(player.mo, ang, -FRACUNIT)
   
   player.mo.state = S_PHOENIX_SOMERSAULT2 //S_PHOENIX_SOMERSAULT
    player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_BUST|STR_SPIKE|STR_SPRING
   player.mo.frame = 0 & ~FF_FRAMEMASK
   player.mo.tics = 3
   player.justspindashed = 16

			//player.chargedelay = min(TICRATE*3/2, $ + TICRATE/3)
			S_StopSound(player.mo)
     //S_StartSound(player.mo, sfx_pwhos1)
			S_StartSound(player.mo, sfx_s3kab + player.dscharge - 1)
   return true
  end
 else
  return
 end
end)*/




addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid)
	and player.mo.skin == SKIN
		local mo = player.mo
		local cmd = player.cmd
		local skinvar = skins[player.mo.skin]
		
	
		if player.spindown ~= nil and (player.cmd.buttons&BT_SPIN)
			player.spindown = $ + 1
		else
			player.spindown = 0
		end


   if (GS_RAILS_SKINS and not GS_RAILS_SKINS["phoenix"]) //and (player.mo.GSgrind)
    GS_RAILS_SKINS["phoenix"] = {}
    local SKIN = GS_RAILS_SKINS["phoenix"]

    SKIN["S_SKIN"] = {
      HEROESTWIST = 4,
      MAXSPEED = 250,
	  STARTMODIFIER = 5,
	  SIDEHOPARC = 10,
    SIDEFLIP = SPR2_SPNG,
    WALLCLINGSPRITE = SPR2_CLNG,
	  AIRDRAG = 36,
	  LAUNCHPOWER = 2,
	  ACCELSPEED = 18,
	  ACCELCAP = 36
     }
	 
	 SKIN["CustomAnim"] = function(p, mo, GS, rail, POSTTHINK, ANIMCALL)
		if (POSTTHINK!=true) return false end 
		
		if mo.GSgrind and GS.grinding and mo.state == S_PLAY_GSGRINDING and not ((mo.sprite2 & ~FF_SPR2SUPER)==SPR2_ROLL or GS.forcesprite==SPR2_ROLL)
			if p.dschargestate == 1
				mo.state = S_PHOENIX_ERGRIND
			elseif GS.railspin or p.dschargestate
				mo.state = S_PHOENIX_CROUCHGRIND
			end
		end
	 end
   end

   if (mo.state == S_PHOENIX_ERGRIND or mo.state == S_PHOENIX_CROUCHGRIND) and not player.powers[pw_carry]
    mo.state = (not P_IsObjectOnGround(mo)) and S_PLAY_FALL or S_PLAY_WALK
   end


   if (player.pflags&PF_STARTJUMP) and player.dsjumptime ~= nil
    player.dsjumptime = max(0, $+1)
   else
    player.dsjumptime = 0
   end


   /*if (player.pflags&PF_JUMPED|PF_STARTJUMP) and player.dsjumptime <= 7 and (player.cmd.buttons&BT_JUMP) and not (player.mo.eflags&MFE_UNDERWATER)
    if (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING)
     if player.dsjumptime <= 4
      player.mo.state = S_PLAY_SPRING
      player.panim = PA_JUMP
     elseif player.dsjumptime and player.mo.state == S_PLAY_SPRING
      player.mo.state = S_PLAY_JUMP
      player.panim = PA_JUMP
     end
    end
   end*/


		if player.justspindashed == nil
			player.justspindashed = 0
		elseif (player.pflags&PF_SPINNING) and not (player.pflags&(PF_STARTDASH)) and P_IsObjectOnGround(mo) //and player.justspindashed >= 0
			player.justspindashed = $ - 1
		else
			player.justspindashed = 16
		end
		
		
		if not player.dspswap
			player.charability = CA_JUMPTHOK
		else
			player.charability = CA_DOUBLEJUMP
		end
		
   //manual frame speed up
		if (player.mo.state == S_PHOENIX_SOMERSAULT and player.speed >= player.runspeed * 2/3)
		or (player.mo.state == S_PHOENIX_SOMERSAULT2 and player.speed >= 14*player.mo.scale)
		/*or ((player.mo.state == S_PLAY_WALK and player.speed < 7*player.mo.scale))
		//or player.mo.state == S_PLAY_RUN and (player.speed >= 49*player.mo.scale and not player.dodynamic))
		and P_IsObjectOnGround(player.mo) and (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0))*/
		//or player.mo.state == S_PLAY_JUMP and (player.pflags&PF_JUMPDOWN)
			if player.mo.tics > 1 //and player.dslastframe ~= player.mo.frame
				player.mo.tics = max($ - 1, 1)
			end
			
			/*if player.mo.state == S_PLAY_WALK //funny adventure walk thing
				
				//player.mo.tics = max($ - 1, 1)

				if player.speed <= 7*player.mo.scale and player.mo.tics
					if player.mo.tics > 1
						player.mo.tics = $ - 1
					end
					if player.mo.tics > 2
						player.mo.tics = $ - 1
					end
				end
			end*/
			player.dslastframe = player.mo.frame
		end
		
		
		
		//     Fake Dashmode
		
		
		local FAKERUNTIME = FRACUNIT //TICRATE * 4/3 //how long before we increase normalspeed
		local LENIENCE = TICRATE
		local FAKERUNTIME2 = 2*TICRATE //how long before we hit our maximum normalspeed
		
		if player.dspfakedashmode == nil
			player.dspfakedashmode = 0
		end
		
		if not (player.isxmomentum) and not (CBW_Battle)
			
			//timer
		
			if player.speed >= 30*player.mo.scale
				
				player.dspfakedashmode = min($ + 1, FAKERUNTIME)
			elseif player.dspfakedashmode
				
				player.dspfakedashmode = max($ - FAKERUNTIME/TICRATE, 0)
			end
			
			
			
			//Normalspeed increase
			
			if P_IsObjectOnGround(player.mo) and player.dspfakedashmode >= LENIENCE and (player.normalspeed < 43*FRACUNIT) and not (player.dschargestate and player.dschargestate >= 2)
			
				//player.normalspeed = max(skins[player.mo.skin].normalspeed, min(42*FRACUNIT, $ + (FRACUNIT * 6 / FAKERUNTIME2)))
			elseif P_IsObjectOnGround(player.mo) and not (player.dschargestate and player.dschargestate >= 2)
				//player.normalspeed = skins[player.mo.skin].normalspeed
			end
		end
		
		//print(player.dspfakedashmode)
		//print(player.normalspeed/FRACUNIT)
		
		


		//      Thok Trail

		if player.mo.state == S_PHOENIX_SAULTJUMP_A or player.mo.state == S_PHOENIX_SAULTJUMP_B or player.mo.state == S_PLAY_TWINSPIN
		//or (player.mo.state == S_PLAY_JUMP) and not (player.pflags&PF_THOKKED) and (player.pflags&PF_JUMPED)
		or (player.mo.state == S_PHOENIX_SOMERSAULT or player.mo.state == S_PHOENIX_SOMERSAULT
		or player.dschargestate == 3 and not (player.pflags&PF_JUMPED))
		
			for i = 0, 1
				local ghost = P_SpawnGhostMobj(mo)
				P_MoveOrigin(ghost, mo.x + i*mo.momx, mo.y + i*mo.momy, mo.z + i*(mo.momz) - FRACUNIT*7)
				

				ghost.state = (player.mo.state == S_PHOENIX_SAULTJUMP_A or player.mo.state == S_PHOENIX_SAULTJUMP_B) and $ or S_THOK
				
				ghost.fuse = (player.mo.state == S_PHOENIX_SAULTJUMP_A or player.mo.state == S_PHOENIX_SAULTJUMP_B) and 4 or 7
				ghost.tics = (player.mo.state == S_PHOENIX_SAULTJUMP_A or player.mo.state == S_PHOENIX_SAULTJUMP_B) and $ or 5
				
				if ghost.state == S_THOK
					ghost.scale = FixedMul(skins[mo.skin].highresscale, mo.scale * (110/100))
					ghost.scalespeed = FRACUNIT/6
					ghost.destscale = 0
					
					if (player.mo.state == S_PHOENIX_SAULTJUMP_B or player.mo.state == S_PLAY_FALL)
						ghost.spriteyscale = FRACUNIT*3/2
					end
					
					if (player.mo.state == S_PHOENIX_SAULTJUMP_B or player.mo.state == S_PLAY_FALL)
						local scaleincrease = max(6, player.mo.frame)
						
						ghost.spriteyscale = min(FRACUNIT*3/2, FRACUNIT + (FRACUNIT/2)/8 * scaleincrease)
					end
				end
				
				ghost.momx = player.mo.momx * (0 + 5*i) / 6
				ghost.momy = player.mo.momy * (0 + 5*i) / 6
				ghost.momz = player.mo.momz * (0 + 5*i) / 6
				//ghost.blendmode = AST_ADD
			end
		end
		
	
		

		if player.dspbuttons == nil
			player.dspbuttons = {}
			for i = 1, #BUTTONS
				player.dspbuttons[BUTTONS[i]] = 0
			end
		else
			for i = 1, #BUTTONS
				player.dspbuttons[BUTTONS[i]] = player.cmd.buttons & BUTTONS[i] and $ + 1 or 0
			end
		end
	
		
		if (player.exiting or (player.cmd.buttons&BT_TOSSFLAG) and player.dspbuttons[BT_CUSTOM1] == 1) and P_IsObjectOnGround(player.mo) and not player.speed and not (player.pflags&PF_SPINNING)
			if (player.mo.state ~= S_PLAY_LEVELFINISH and player.mo.state ~= S_PLAY_LEVELFINISHREPEAT)
				player.mo.state = S_PLAY_LEVELFINISH
			end
		end
		
		if (player.mo.state == S_PLAY_LEVELFINISH or player.mo.state == S_PLAY_LEVELFINISHREPEAT)
			player.pflags = $|PF_STASIS
		end
		
		if P_IsObjectOnGround(player.mo) and player.mo.state == S_PLAY_GLIDE_LANDING and player.spinslashstate ~= 1
			player.pflags = $|PF_STASIS
			if player.speed > FRACUNIT*2
				P_SpawnSkidDust(player, FRACUNIT*8, sfx_airdsh)
			end
		end
		
		if not (player.exiting) and P_IsObjectOnGround(player.mo) and (player.panim == PA_IDLE) and (player.aiming*P_MobjFlip(player.mo) >= ANG15)
			player.mo.state = S_PHOENIX_LOOKUP
			player.panim = PA_IDLE
		end
		
		
		
		if player.scharge == nil
			player.scharge = 0
			player.chargedelay = 0
		end

		player.chargedelay = (player.pflags&PF_SPINDOWN) and $ or max($-4, 0)


		
		if player.batterydsh_state == nil
			player.batterydsh_state = 0
			player.batterydsh_count = 0
		end
		
		/*if player.mo.state == PHOENIX_LONGJUMP and (player.pflags&PF_JUMPED)
			player.mo.tics = $-1
		end*/
		
		if (player.mo.state == S_PLAY_ROLL and (player.justspindashed <= 1)
			or player.mo.state == PHOENIX_LONGJUMP or player.mo.state == PHOENIX_SUPERJUMP
			or (player.mo.state == S_PHOENIX_SAULTJUMP_A or player.mo.state == S_PHOENIX_SAULTJUMP_B)
			or (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_STND)) //stops these animations from playing while spinning/sliding
			and not (player.pflags&PF_JUMPED) and (player.pflags&PF_SPINNING)
			and P_IsObjectOnGround(player.mo) 
			and not player.powers[pw_carry]
			and not (player.ds_electronrush ~= nil and player.ds_electronrush.state == 3)
				player.mo.state = (player.mo.state == PHOENIX_LONGJUMP or player.mo.state == PHOENIX_SUPERJUMP or player.mo.state == S_PHOENIX_SAULTJUMP_A or player.mo.state == S_PHOENIX_SAULTJUMP_B) and S_PLAY_ROLL or PHOENIX_SLIDE
		end
		
		if player.batterydsh_state == 1
			player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPIKE
			if player.mo.state ~= PHOENIX_BATTERYD1 and player.mo.state ~= PHOENIX_BATTERYD2 and player.mo.state ~= PHOENIX_SLIDE and player.mo.state ~= S_PLAY_FALL
				player.batterydsh_state = 0
				player.powers[pw_strong] = STR_NONE
			//elseif player.mo.state == PHOENIX_BATTERYD1
				//player.mo.state = PHOENIX_BATTERYD1
			end
		end

	   player.yadashspeed = YADSPEED

	   if (player.powers[pw_shield] == SH_THUNDERCOIN or player.powers[pw_shield] == SH_ATTRACT
	   or (player.powers[pw_shield] & SH_PROTECTELECTRIC) or player.powers[pw_shield] == SH_WHIRLWIND)
		player.yadashspeed = CBW_Battle and FixedMul(YADSPEED * 100/72, skins[SKIN].normalspeed/36) or FixedMul(YADSPEED * 150/60, skins[SKIN].normalspeed/36)
	   end
	   
	   if CBW_Battle
		player.yadashspeed = FixedMul($, FRACUNIT*42/72)
	   end
	   
	  

	  if (player.mo.state == S_PLAY_MELEE_LANDING or player.mo.state == S_PLAY_GLIDE_LANDING) and (P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR))
	   player.pflags = $|PF_STASIS
	  end

	  if player.dschargestate == nil
	   player.dschargestate = 0
	   player.dscharge = 0
	  end

	  if not player.dschargestate and player.oldthrustfactor
	   player.thrustfactor = player.oldthrustfactor
	   player.oldthrustfactor = nil
	  end



	 //  Charging the Electron Rush

	  if player.dschargestate == 1

	   player.dscharge = $ + 1
	   player.pflags = $ & ~PF_STASIS //remove it

	   player.drawangle = player.mo.angle
	   player.fakeforwardmove = player.cmd.forwardmove
	   player.fakesidemove = player.cmd.sidemove

	   if not player.oldthrustfactor
		player.oldthrustfactor = player.thrustfactor
	   end

	   player.thrustfactor = player.oldthrustfactor *3/4

	   if P_IsObjectOnGround(player.mo)
	   //player.pflags = $|PF_STASIS //add it back


	   //fake movement
	   local acceleration = player.accelstart
	   local controlang = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.fakeforwardmove*FRACUNIT, -player.fakesidemove*FRACUNIT)

	   /*P_Thrust(player.mo, controlang, FixedMul(acceleration * 1/4, R_PointToDist2(0, 0, player.fakeforwardmove*FRACUNIT, player.fakesidemove*FRACUNIT)/50))
	   player.mo.momx = FixedMul($, FixedMul(sin(controlang), player.acceleration) + FixedMul(cos(controlang), player.acceleration))
	   player.mo.momy = FixedMul($, FixedMul(cos(controlang), player.acceleration) + FixedMul(sin(controlang), player.acceleration))
	   P_MovePlayer(player)*/
	   end

	   
	   if (player.powers[pw_shield] & SH_FORCE) and not (player.dontdothemove)
		 player.mo.momx = $ - $/8
		 player.mo.momy = $ - $/8
		elseif P_IsObjectOnGround(player.mo)
		 player.mo.momx = $ * 34/36
		 player.mo.momy = $ * 34/36
		 
		 if player.speed <= FRACUNIT*3
		  player.mo.momx = $ * 2/6
		  player.mo.momy = $ * 2/6
		 end
		end

	   player.mo.friction = FRACUNIT*97/100
	   if not player.powers[pw_carry]
	   and not player.dsp_batterydashst
		player.mo.state = P_IsObjectOnGround(player.mo) and S_PLAY_GLIDE_LANDING or (player.mo.momz*P_MobjFlip(player.mo) < -12*FRACUNIT and not (player.cmd.buttons&BT_JUMP)) and S_PLAY_FALL or S_PLAY_SPINDASH
	   elseif player.powers[pw_carry] == 3888 and player.mo.state == S_PLAY_GSGRINDING
		player.mo.state = S_PHOENIX_ERGRIND
	   end
	   
	   
	   
	   /*if (player.mo.eflags&MFE_JUSTHITFLOOR) and (player.prevpflags ~= nil and player.prevpflags&PF_JUMPED) and (player.cmd.buttons&BT_JUMP)
		player.mo.state = S_PLAY_MELEE_LANDING
		player.mo.tics = TICRATE/3
		player.pflags = $|PF_STASIS & ~(PF_THOKKED|PF_SPINNING)
		S_StartSound(player.mo, sfx_s3k9b)
		P_StartQuake(8*FRACUNIT, 5)
		player.dschargestate = 0
		player.dscharge = 0
	   else*/
	   

	  // Launch it!

	   if (player.dscharge >= TICRATE*5/12 and (P_IsObjectOnGround(player.mo))
	   or (player.dscharge >= TICRATE*4/12 and (player.powers[pw_carry] and player.powers[pw_carry] ~= 8 and player.powers[pw_carry] ~= 6 and player.powers[pw_carry] ~= 2
	   and player.powers[pw_carry] ~= 11 and player.powers[pw_carry] ~= 3 and player.powers[pw_carry] ~= 12 and player.powers[pw_carry] ~= 7))
	   or player.dsp_batterydashst and (player.mo.eflags&MFE_JUSTHITFLOOR))
	   and not player.gotflag and (player.cmd.buttons&BT_SPIN)
		player.dschargestate = 2
		player.dscharge = 0

		 if (player.yadashspeed > YADSPEED)
		  player.normalspeed = max($, 54*FRACUNIT) //want a head start for the super dashspeed
		 end
		

		local thrustang = (player.powers[pw_carry] ~= 0 and player.powers[pw_carry] ~= 13) and player.drawangle or player.mo.angle

		if (P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR) or player.powers[pw_carry] == 10 or player.powers[pw_carry] == 13 or player.powers[pw_carry] == 3888)
		 player.mo.state = (player.powers[pw_carry]) and $ or S_PLAY_RUN

		if player.speed < player.runspeed

		if player.mo.GSgrind and player.mo.GSgrind.grinding and RailType(mo, player.mo.GSgrind.myrail) ~= 2
		 player.mo.GSgrind.railspeed = max(abs(player.mo.GSgrind.railspeed or 0) + 18*FRACUNIT, player.normalspeed) *GS_RAILS.GrindFlip(mo, mo.GSgrind.myrail, true)
		elseif player.powers[pw_carry] ~= 3888

		 P_InstaThrust(player.mo, thrustang, max(max(player.speed, player.prevmom) + 18*FRACUNIT, player.normalspeed))
		end
		else

		if player.mo.GSgrind and player.mo.GSgrind.grinding and RailType(mo, player.mo.GSgrind.myrail) ~= 2
		 local GS = player.mo.GSgrind

		 GS.railspeed = max(abs(player.mo.GSgrind.railspeed) + 8*FRACUNIT, 51*FRACUNIT) *GS_RAILS.GrindFlip(mo, GS.myrail, true)
		elseif player.powers[pw_carry] ~= 3888

		 P_InstaThrust(player.mo, thrustang, max(max(player.speed, player.prevmom) + 8*FRACUNIT, 51*FRACUNIT))
		end
		end

		if not (player.powers[pw_carry])
		  P_MovePlayer(player)
		
			local radius = player.mo.radius >> FRACBITS
				P_SpawnMobjFromMobj(player.mo, P_RandomRange(-radius, radius) << FRACBITS, P_RandomRange(-radius, radius) << FRACBITS, 0, MT_DUST)
				P_SpawnMobjFromMobj(player.mo, P_RandomRange(-radius, radius) << FRACBITS, P_RandomRange(-radius, radius) << FRACBITS, 0, MT_DUST)
				P_SpawnMobjFromMobj(player.mo, P_RandomRange(-radius, radius) << FRACBITS, P_RandomRange(-radius, radius) << FRACBITS, 0, MT_DUST)
				P_SpawnMobjFromMobj(player.mo, P_RandomRange(-radius, radius) << FRACBITS, P_RandomRange(-radius, radius) << FRACBITS, 0, MT_DUST)
		end
		player.prevmom = 0
		end

		player.pflags = $ & ~(PF_SPINNING|PF_STASIS)
		S_StartSound(player.mo, sfx_cdfm01)
		S_StartSound(player.mo, sfx_s3k45)
		S_StopSoundByID(player.mo, sfx_monton)
		P_StartQuake(FRACUNIT*15, 6)

		/*if player.speed <= FRACUNIT
		player.mo.z = $ + FRACUNIT * P_MobjFlip(player.mo)
		P_SetObjectMomZ(player.mo, -2*FRACUNIT, true)
		player.pflags = $|PF_THOKKED
		end*/



		//Static Spin & Insta-Flip
	   elseif ((player.cmd.buttons&BT_JUMP) and P_IsObjectOnGround(player.mo) or not (player.cmd.buttons&BT_SPIN)) and not player.dsp_batterydashst and not (player.powers[pw_carry])
		player.dschargestate = 3
		S_StartSoundAtVolume(player.mo, sfx_pwhos1, 40)
		player.dscharge = 1
		player.mo.state = S_PHOENIX_SOMERSAULT
		  player.mo.frame = 0
		
		if player.gotflag > 0 or (player.pflags&PF_SHIELDABILITY) or P_IsObjectOnGround(player.mo) or (player.dontdothemove) or CBW_Battle
		 S_StartSound(player.mo, sfx_s3ka2)
		 if not (player.gotflag and not P_IsObjectOnGround(player.mo))
		 local minspeed = (player.cmd.buttons&BT_SPIN) and 36*FRACUNIT or 24*FRACUNIT

		 P_InstaThrust(player.mo, player.mo.angle, max(max(player.speed, player.prevmom), minspeed))
		 end
		end

	   local enemy = P_LookForEnemies(player, true, true)
	   
	  
		
		if not P_IsObjectOnGround(player.mo)
			player.mo.state = S_PLAY_TWINSPIN

	   if not (player.pflags&PF_SHIELDABILITY) and (player.dontdothemove < 2) and not CBW_Battle
	   if (player.gotflag == 0)
		if (player.cmd.buttons&BT_CUSTOM1) and not player.dontdothemove
		and (player.powers[pw_shield] == SH_ARMAGEDDON or player.powers[pw_shield] == SH_FLAMEAURA
		or player.powers[pw_shield] == SH_WHIRLWIND or player.powers[pw_shield] == SH_THUNDERCOIN)
			if (player.powers[pw_shield] == SH_ARMAGEDDON)
			 //P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
			 P_SetObjectMomZ(player.mo, 15*FRACUNIT)
			 P_BlackOw(player)
			 player.pflags = $|PF_SHIELDABILITY
			 player.mo.state = S_PLAY_ROLL
			 player.dschargestate = 0
			end
			
			if (player.powers[pw_shield] == SH_FLAMEAURA)
			 player.mo.state = S_PLAY_ROLL
			 P_Thrust(player.mo, player.mo.angle, 30*FRACUNIT)
			 S_StartSound(player.mo, sfx_s3k43)
			 player.pflags = $|PF_SHIELDABILITY
			 player.dschargestate = 0
			end
			
			if (player.powers[pw_shield] == SH_WHIRLWIND)
			 P_DoJumpShield(player)
			 player.pflags = $|PF_SHIELDABILITY|PF_JUMPED
			 player.mo.state = S_PLAY_FALL
			 S_StartSound(player.mo, sfx_wdjump)
			 P_SetObjectMomZ(player.mo, FRACUNIT*10)
			end
			
			if (player.powers[pw_shield] == SH_THUNDERCOIN)
			 player.pflags = $ & ~PF_THOKKED
			 P_DoJumpShield(player)
			 player.pflags = $|PF_THOKKED|PF_SHIELDABILITY|PF_JUMPED & ~PF_STARTJUMP
			 player.mo.state = S_PLAY_ROLL
			 S_StartSound(player.mo, sfx_s3k45)
			 P_SetObjectMomZ(player.mo, FRACUNIT*14)
			 player.dschargestate = 0
			/*elseif (player.powers[pw_shield] == SH_ELEMENTAL) and not player.dontdothemove
			 player.pflags = $|PF_SHIELDABILITY
			 player.mo.state = S_PLAY_ROLL
			 player.mo.momx = $/2
			 player.mo.momy = $/2
			 P_SetObjectMomZ(player.mo, min(player.mo.momz*P_MobjFlip(mo) - 10*FRACUNIT, -FRACUNIT*20))*/
			 end
		else

		if (player.powers[pw_shield] & SH_FORCE) and not player.dontdothemove
		 P_InstaThrust(player.mo, player.mo.angle, max(max(player.speed, player.prevmom), 24*FRACUNIT))
		 player.mo.momz = 0
		 player.pflags = $|PF_SHIELDABILITY
		 player.mo.state = S_PLAY_FALL
		 S_StartSound(player.mo, sfx_ngskid)
		else
		 P_InstaThrust(player.mo, player.mo.angle, max(max(player.speed, player.prevmom), 24*FRACUNIT))

				local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PINSTASHIELD)
				instashield.target = player.mo
				instashield.scale = player.mo.scale * 5/4
				instashield.fuse = 12
				player.mo.tracer = instashield	
				if (player.realmo.eflags & MFE_VERTICALFLIP)
					instashield.eflags = $|MFE_VERTICALFLIP
				end
				P_SpawnThokMobj(player)

		 S_StartSound(player.mo, sfx_s3ka2)
		end

		if (enemy and enemy.valid) and R_PointToDist2(player.mo.x, player.mo.y, enemy.x, enemy.y) <= 650*FRACUNIT
		 player.mo.state = S_PLAY_ROLL
		 //print(R_PointToDist2(player.mo.x, player.mo.y, enemy.x, enemy.y)/FRACUNIT)
		 P_HomingAttack(player.mo, enemy)
		 player.homingdash = TICRATE*2/3
		 player.dschargestate = 0
		 player.mo.momz = $ + FixedMul(4*FRACUNIT, enemy.scale)*P_MobjFlip(player.mo)
		 player.mo.target = enemy
		 player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPIKE|STR_SPRING
		 player.pflags = $|PF_SPINNING|PF_THOKKED
		 
		  if not player.dsp_storednormalspeed
		  player.dsp_storednormalspeed = player.normalspeed
		  end
		  player.normalspeed = player.actionspd
		end
	   end
		end
	  end
	  end
		
		player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPIKE|STR_SPRING
		player.pflags = $|PF_SPINNING|PF_THOKKED & ~PF_STASIS
		S_StopSoundByID(player.mo, sfx_monton)
		player.dontdothemove = $ + 1 or 0
		
		if P_IsObjectOnGround(player.mo)
			S_StartSound(player.mo, sfx_zoom)
		elseif not ((player.pflags&PF_SHIELDABILITY) and player.dontdothemove < 2)
			S_StartSound(player.mo, sfx_thok)
			if CBW_Battle
			S_StartSound(player.mo, sfx_s3ka2)
			end
		end
		
		player.prevmom = 0
	   end
	  end
	  
	  

		if player.dschargestate == 2
			player.charability2 = CA2_NONE
			player.actionspd = 5*FRACUNIT
			
			/*if not player.machspeedmode and not player.genphys and not player.rphys and not (player.cmd.forward == 0 and player.cmd.sidemove == 0)
				player.mo.friction = $ + FixedMul(R_PointToDist2(0, 0, player.cmd.forwardmove*FRACUNIT, player.cmd.sidemove*FRACUNIT)/50, FRACUNIT*97/99-$)
			end
			
			if not player.oldthrustfactor
				player.oldthrustfactor = player.thrustfactor
			end
			
			player.thrustfactor = P_IsObjectOnGround(player.mo) and player.oldthrustfactor * 4/5 or player.oldthrustfactor * 5/3*/
			
			player.pflags = $ & ~PF_STASIS
			player.charflags = $|SF_RUNONWATER //& ~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
			
			player.powers[pw_strong] = $|STR_SPIKE
			if (player.yadashspeed > YADSPEED)
				player.normalspeed = $ + FRACUNIT/15
			end 
			player.normalspeed = max(skins[mo.skin].normalspeed + FRACUNIT*9, min(player.yadashspeed, player.normalspeed + FRACUNIT/15))
			
			if (leveltime%3) == 1 //and player.normalspeed >= player.yadashspeed * 42/54
				local ghost = P_SpawnGhostMobj(mo)
				ghost.fuse = 5
				ghost.colorized = true
			end
			
			if P_IsObjectOnGround(player.mo) and (player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_RUN)
			and (player.powers[pw_shield] == SH_ELEMENTAL) and not (player.gotflag ~= 0)
				P_ElementalFire(player)
			end
			
			if CBW_Battle ~= nil
				player.charability = skins[mo.skin].ability
			else
				player.charability = (player.gotflag) and CA_NONE or CA_JUMPBOOST
			end
			
			if not (player.cmd.buttons&BT_SPIN) or P_PlayerInPain(player) or player.playerstate == PST_REBORN or player.mo.state == S_PLAY_PAIN
				player.dschargestate = 0
				player.normalspeed = skins[mo.skin].normalspeed
				player.charability = skins[mo.skin].ability
				player.charability2 = skins[mo.skin].ability2
				player.actionspd = skins[mo.skin].actionspd
				//player.charflags = $ & ~SF_RUNONWATER
				player.powers[pw_strong] = STR_NONE
			end
		end
   
   

		if player.dschargestate == 3
			
			if player.mo.state ~= S_PHOENIX_SOMERSAULT and player.mo.state ~= S_PLAY_TWINSPIN and player.mo.state ~= S_PLAY_SPINDASH and player.mo.state ~= S_PLAY_ROLL and player.mo.state ~= S_PHOENIX_SOMERSAULT2 or (player.mo.state == S_PLAY_ROLL and player.justspindashed <= 1)
				player.dschargestate = 0
				player.dscharge = 0
				player.normalspeed = skins[mo.skin].normalspeed
				player.powers[pw_strong] = STR_NONE
				
				
				if not (player.cmd.buttons&BT_SPIN) or not ((player.cmd.buttons&BT_JUMP) and not (player.pflags&PF_JUMPDOWN)) and (player.pflags&PF_JUMPED) //player.mo.state ~= S_PLAY_MELEE_FINISH
					player.pflags = (player.pflags&PF_JUMPED) and $ & ~(PF_SPINNING) or $ & ~(PF_SPINNING|PF_THOKKED)
				
					if player.mo.state == PHOENIX_SLIDE
						player.mo.state = S_PLAY_WALK
					end
					player.dscharge = 0
				else
					player.dscharge = 0
					
					if not (mo.eflags&MFE_JUSTHITFLOOR) and not (P_IsObjectOnGround(mo))
					
						player.mo.state = S_PLAY_ROLL
						player.pflags = $|PF_SPINNING & ~(PF_JUMPED|PF_THOKKED)
					else
						player.mo.state = PHOENIX_SLIDE
						player.pflags = $|PF_SPINNING & ~PF_THOKKED
					end
				end
				
				return
			else
				player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPIKE|STR_SPRING
				
				if not (player.pflags&PF_JUMPED)
					player.pflags = $|PF_SPINNING|PF_THOKKED
				end
				
				if player.isxmomentum
					player.fakenormalspeed = 46*FRACUNIT - FixedMul(player.dscharge * FRACUNIT, player.mo.scale)
				else
					player.normalspeed = 46*FRACUNIT - FixedMul(player.dscharge * FRACUNIT, player.mo.scale)
				end
			end
		end
  
  
  
		if not (player.pflags&PF_JUMPED) and not P_IsObjectOnGround(player.mo)
		and not (player.mo.eflags&MFE_JUSTHITFLOOR) and not player.powers[pw_carry]
		and not (player.pflags&PF_SPINNING) and not (player.yetanother_walljump)
		and (player.mo.eflags&MFE_UNDERWATER)
			player.pflags = $|PF_JUMPED
		end


	  if player.homingdash == nil
	   player.homingdash = 0
	  elseif player.homingdash > 0
		 player.homingdash = max($-1, 0)
		 if (player.mo.target and player.mo.target.valid) and player.mo.state == S_PLAY_ROLL and not (player.mo.eflags&MFE_SPRUNG)
		  P_SpawnThokMobj(player)
		player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPIKE|STR_SPRING
		

		  local ang = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.target.x, player.mo.target.y)

		  player.mo.angle = ang
		  player.drawangle = ang
		  if not player.dsp_storednormalspeed
		  player.dsp_storednormalspeed = player.normalspeed
		  end
		  player.normalspeed = player.actionspd
		  P_HomingAttack(player.mo, player.mo.target)
		local ghost = P_SpawnGhostMobj(mo)
		ghost.fuse = 5
		ghost.state = S_THOK
		ghost.destscale = 1
		 elseif player.mo.state == S_PLAY_ROLL and not (player.mo.eflags&MFE_SPRUNG)
			player.mo.momx = $/2
			player.mo.momy = $/2
			player.mo.momz = $/2
		 else
			player.normalspeed = player.dsp_storednormalspeed
			player.dsp_storednormalspeed = nil
			player.homingdash = 0
			player.powers[pw_strong] = STR_NONE
			if not (player.mo.target and player.mo.target.valid)
			player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
			end
		 end
	  end
  
  
	  if player.dsp_storednormalspeed and not player.homingdash
		player.normalspeed = player.dsp_storednormalspeed
		player.dsp_storednormalspeed = nil
		player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
	  end

	  if P_IsObjectOnGround(player.mo) or not (player.pflags&PF_JUMPED)
	   player.dontdothemove = 0
	  end

	   if P_PlayerInPain(player) or player.playerstate ~= PST_LIVE or player.mo.state == S_PLAY_PAIN and player.dschargestate or (player.yetanother_walljump and player.dschargestate ~= 2)
	   player.dschargestate = 0
	   player.dscharge = 0
		player.normalspeed = skins[mo.skin].normalspeed
		player.charability = skins[mo.skin].ability
		player.charability2 = skins[mo.skin].ability2
		  player.actionspd = skins[mo.skin].actionspd
		  //player.charflags = $ & ~SF_RUNONWATER
		player.powers[pw_strong] = STR_NONE
	   return
	   end

	  player.prevpflags = player.pflags
	else
		return
	end
end)




/*addHook("JumpSpinSpecial", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == SKIN and not CBW_Battle
		
	if player.scharge == 0 and player.spindown == 11 and not (player.pflags&PF_THOKKED) //and not (player.pflags&PF_SPINNING)
			player.mo.state = PHOENIX_DROPDASH
			player.pflags = $|PF_SPINNING|PF_THOKKED
			player.scharge = 1
			player.chargedelay = TICRATE
			//P_InstaThrust(player.mo, player.mo.angle, max(player.speed + 4*FRACUNIT, 6*FRACUNIT))
			S_StartSound(player.mo, sfx_s3kab)
			return true
		end*
	
		if not (player.pflags&PF_SPINDOWN) and not (player.pflags&PF_THOKKED) and not (player.pflags&PF_SHIELDABILITY) 
			//P_SetObjectMomZ(player.mo, WaterFactor(player.mo, FRACUNIT*10 + player.scharge/3 * FRACUNIT, 1))
				if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
					//P_InstaThrust(player.mo, player.mo.angle, max(WaterFactor(player.mo, FRACUNIT*24), player.speed))
				else
					P_SetObjectMomZ(player.mo, FRACUNIT*2, true)
					player.mo.momx = $/2
					player.mo.momy = $/2
				end*


     //P_SpawnThokMobj(player)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED

			//S_StopSound(player.mo)
			S_StartSound(player.mo, sfx_s3k42)
		
			local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PINSTASHIELD)
			instashield.target = player.mo
			instashield.scale = player.mo.scale * 5/4
			instashield.fuse = 12
			player.mo.tracer = instashield	
			if (player.realmo.eflags & MFE_VERTICALFLIP)
				instashield.eflags = $|MFE_VERTICALFLIP
			end
			return true
		end
	else
		return
	end
end)





addHook("MobjDamage", function(enemy, freedom, freedom)
	if (freedom and freedom.valid) and (freedom.player) and not CBW_Battle
	 if freedom.skin ~= SKIN then return end
		if (enemy and enemy.valid)
		and (enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS or enemy.flags & MF_SHOOTABLE)
		and not P_IsObjectOnGround(freedom)
			freedom.player.pflags = $1 & ~(PF_THOKKED)
			freedom.player.dontdothemove = 0
			
			if freedom.player.homingdash > 0
				freedom.player.homingdash = 0
				freedom.state = S_PLAY_FALL
				freedom.momz = $ * 3/8
				S_StartSound(freedom, sfx_zoom)
				freedom.player.powers[pw_strong] = STR_NONE
       
				P_SetObjectMomZ(freedom, max(freedom.momz*P_MobjFlip(freedom), 10*FRACUNIT))
				freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//if freedom.state == S_PLAY_ROLL
					//freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//end
			end
		end
		return false
	end
end)

addHook("MobjDeath", function(enemy, freedom, freedom)
	if (freedom and freedom.valid) and (freedom.player) and not CBW_Battle
	 if freedom.skin ~= SKIN then return end
		if (enemy and enemy.valid)
		and (enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS or enemy.flags & MF_SHOOTABLE)
		and not P_IsObjectOnGround(freedom)
			freedom.player.pflags = $1 & ~(PF_THOKKED)
			freedom.player.dontdothemove = 0
			
			if freedom.player.homingdash > 0
				freedom.player.homingdash = 0
				freedom.state = S_PLAY_FALL
				freedom.momz = $ * 3/8
				S_StartSound(freedom, sfx_zoom)
				freedom.player.powers[pw_strong] = STR_NONE
       
				P_SetObjectMomZ(freedom, max(freedom.momz*P_MobjFlip(freedom), 10*FRACUNIT))
				freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//if freedom.state == S_PLAY_ROLL
					//freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//end
			end
		end
		return false
	end
end)

addHook("MobjDeath", function(enemy, freedom, freedom)
	if (freedom and freedom.valid) and (freedom.player)
	 if freedom.skin ~= SKIN then return end
		if (enemy and enemy.valid)
		and (enemy.flags & MF_MONITOR)
		and not P_IsObjectOnGround(freedom)
			freedom.player.pflags = $1 & ~(PF_THOKKED)
			freedom.player.dontdothemove = 0
			
			if freedom.player.homingdash > 0
				freedom.player.homingdash = 0
				freedom.state = S_PLAY_FALL
				freedom.momz = $ * 3/8
				S_StartSound(freedom, sfx_zoom)
				freedom.player.powers[pw_strong] = STR_NONE
       
				P_SetObjectMomZ(freedom, max(freedom.momz*P_MobjFlip(freedom), 10*FRACUNIT))
				freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//if freedom.state == S_PLAY_ROLL
					//freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//end
			end
		end
		return false
	end
end)

addHook("MobjDamage", function(enemy, freedom, freedom)
	if (freedom and freedom.valid) and (freedom.player)
	 if freedom.skin ~= SKIN then return end
		if (enemy and enemy.valid)
		and (enemy.flags & MF_MONITOR)
		and not P_IsObjectOnGround(freedom)
			freedom.player.pflags = $1 & ~(PF_THOKKED)
			freedom.player.dontdothemove = 0
			
			if freedom.player.homingdash > 0
				freedom.player.homingdash = 0
				freedom.state = S_PLAY_FALL
				freedom.momz = $ * 3/8
				S_StartSound(freedom, sfx_zoom)
				freedom.player.powers[pw_strong] = STR_NONE
       
				P_SetObjectMomZ(freedom, max(freedom.momz*P_MobjFlip(freedom), 10*FRACUNIT))
				freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//if freedom.state == S_PLAY_ROLL
					//freedom.player.pflags = $1 & ~(PF_SPINNING|PF_THOKKED)
				//end
			end
		end
		return false
	end
end)

addHook("MobjDamage", function(phoenix, _, _, dmg, type)
 if phoenix and phoenix.valid and phoenix.player and phoenix.skin == SKIN and not phoenix.player.gotflag
  if dmg and type ~= DMG_ELECTRIC then return end

  phoenix.player.powers[pw_flashing] = 1
  return true
 else return
 end
end, MT_PLAYER)*/