local SKIN = "phoenix"
local DASHTIME = (CBW_Battle) and TICRATE*3/2 or 4*TICRATE

freeslot(
	"MT_PINSTASHIELD",
	"S_PINSTASHIELD",
	"S_PINSTASHIELD1A",
	"S_PINSTASHIELD1B",
	"S_PINSTASHIELD2A",
	"S_PINSTASHIELD2B",
	"S_PINSTASHIELD3A",
	"S_PINSTASHIELD3B",
	"S_PINSTASHIELD4A",
	"S_PINSTASHIELD4B",
	"S_PINSTASHIELD5A",
	"S_PINSTASHIELD5B",
	"S_PINSTASHIELD6A",
	"S_PINSTASHIELD6B",
  "S_PINSTAWHIP",
	"S_PINSTAWHIP1A",
	"S_PINSTAWHIP1B",
	"S_PINSTAWHIP2A",
	"S_PINSTAWHIP2B",
	"S_PINSTAWHIP3A",
	"S_PINSTAWHIP3B",
	"S_PINSTAWHIP4A",
	"S_PINSTAWHIP4B",
	"S_PINSTAWHIP5A",
	"S_PINSTAWHIP5B",
	"S_PINSTAWHIP6A",
	"S_PINSTAWHIP6B",
	"SPR_PINT"
)

mobjinfo[MT_PINSTASHIELD] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_PINSTASHIELD,
	radius = 22*FRACUNIT,
	height = 6*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_MISSILE
}

states[S_PINSTASHIELD] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_PINSTASHIELD1A}
states[S_PINSTASHIELD1A] = {SPR_PINT, 0|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_CapeChase, 0, 0, S_PINSTASHIELD1B}
states[S_PINSTASHIELD1B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_PINSTASHIELD2A}
states[S_PINSTASHIELD2A] = {SPR_PINT, 1|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_CapeChase, 0, 0, S_PINSTASHIELD2B}
states[S_PINSTASHIELD2B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_PINSTASHIELD3A}
states[S_PINSTASHIELD3A] = {SPR_PINT, 2|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_CapeChase, 0, 0, S_PINSTASHIELD3B}
states[S_PINSTASHIELD3B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_PINSTASHIELD4A}
states[S_PINSTASHIELD4A] = {SPR_PINT, 3|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_CapeChase, 0, 0, S_PINSTASHIELD4B}
states[S_PINSTASHIELD4B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_PINSTASHIELD5A}
states[S_PINSTASHIELD5A] = {SPR_PINT, 4|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_CapeChase, 0, 0, S_PINSTASHIELD5B}
states[S_PINSTASHIELD5B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_PINSTASHIELD6A}
states[S_PINSTASHIELD6A] = {SPR_PINT, 5|FF_FULLBRIGHT|FF_PAPERSPRITE, 1, A_CapeChase, 0, 0, S_PINSTASHIELD6B}
states[S_PINSTASHIELD6B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NULL}


//Insta Whip Variant

states[S_PINSTAWHIP] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP1A}
states[S_PINSTAWHIP1A] = {SPR_PINT, 0|FF_FULLBRIGHT|FF_FLOORSPRITE, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP1B}
states[S_PINSTAWHIP1B] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP2A}
states[S_PINSTAWHIP2A] = {SPR_PINT, 1|FF_FULLBRIGHT|FF_FLOORSPRITE, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP2B}
states[S_PINSTAWHIP2B] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP3A}
states[S_PINSTAWHIP3A] = {SPR_PINT, 2|FF_FULLBRIGHT|FF_FLOORSPRITE, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP3B}
states[S_PINSTAWHIP3B] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP4A}
states[S_PINSTAWHIP4A] = {SPR_PINT, 3|FF_FULLBRIGHT|FF_FLOORSPRITE, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP4B}
states[S_PINSTAWHIP4B] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP5A}
states[S_PINSTAWHIP5A] = {SPR_PINT, 4|FF_FULLBRIGHT|FF_FLOORSPRITE, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP5B}
states[S_PINSTAWHIP5B] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP6A}
states[S_PINSTAWHIP6A] = {SPR_PINT, 5|FF_FULLBRIGHT|FF_FLOORSPRITE, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_PINSTAWHIP6B}
states[S_PINSTAWHIP6B] = {SPR_NULL, 0, 1, A_CapeChase, 11*FRACUNIT, FRACUNIT*1, S_NULL}


addHook("MobjThinker", function(insta)
	if not (insta and insta.valid) return end
	if (insta.target)
		if (insta.target.state ~= S_PHOENIX_BATTWIN and insta.target.state ~= S_PLAY_ROLL and insta.target.state ~= S_PHOENIX_BATMLEE and insta.target.state ~= S_PHOENIX_BATMLEL and insta.target.state ~= S_PLAY_JUMP and insta.target.state ~= S_PLAY_SKID)
			insta.target.ISoccur = false
			if insta.flash
				insta.target.colorized = false
			end
			pcall(P_RemoveMobj, insta)
			return
		end

		insta.target.player.powers[pw_strong] = $|STR_ANIM|STR_GUARD
		insta.target.ISoccur = true

   if insta.state >= S_PINSTAWHIP
   insta.z = insta.target.z + insta.target.height/2
   elseif insta.flipit
   insta.frame = $|FF_HORIZONTALFLIP
   end

		if insta.flash
			if (insta.sprite == SPR_NULL)
				insta.target.colorized = false
			else
				insta.target.colorized = true
				insta.angle = insta.target.player.drawangle
				insta.target.frame = ($ & FF_FRAMEMASK)|FF_FULLBRIGHT
			end
			insta.angle = insta.target.player.drawangle
		end
	else
		return
	end
end, MT_PINSTASHIELD)

addHook("ShouldDamage", function(sonic, inflictor, source, damage, element)
	if (sonic.tracer) and sonic.tracer.type == MT_PINSTASHIELD
		if not (element & DMG_DEATHMASK) and not (CBW_Battle)
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(insta, mobj)
	if not (insta.z-FixedMul(24*FRACUNIT, insta.scale) > mobj.z+mobj.height) and not(mobj.z-FixedMul(24*FRACUNIT, insta.scale) > insta.z+insta.height) and not (CBW_Battle)
		if (mobj.valid and (mobj.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) or (mobj.flags & MF_PUSHABLE and mobj.flags & MF_SHOOTABLE))) and not (mobj.flags2 & MF2_FRET)
			P_DamageMobj(mobj, insta, insta.target)
			if P_MobjFlip(insta.target)*insta.target.momz < 0
				insta.target.momz = -$
       insta.target.player.pflags = $ & ~PF_THOKKED
			end
			if (mobj.info.spawnhealth > 1)
				insta.target.momy = -$
				insta.target.momx = -$
			end
			if insta.target.player and (insta.target.player.ds_electronrush ~= nil) and not P_IsObjectOnGround(insta.target) and insta.target.player.ds_electronrush.state == 4 and insta.target.state == S_PHOENIX_BATTWIN
				insta.target.player.ds_electronrush.state = 0
				insta.target.state = S_PLAY_ROLL
				insta.target.player.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
				insta.target.player.canelectronrush = true
			end
		end
	end
end, MT_PINSTASHIELD)





freeslot("S_PHOENIX_BATMLEE", "S_PHOENIX_BATMLEL", "S_PHOENIX_BATTWIN")

states[S_PHOENIX_BATMLEE] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_MLEE,
		var1 = S_PHOENIX_BATMLEL,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_BATMLEE
}

states[S_PHOENIX_BATTWIN] = {
		sprite = SPR_PLAY,
		frame = A|FF_SPR2ENDSTATE|SPR2_TWIN,
		var1 = S_PLAY_ROLL,
		var2 = 0,
		tics = 3,
		nextstate = S_PHOENIX_BATTWIN
}

states[S_PHOENIX_BATMLEL] = {
		sprite = SPR_PLAY,
		frame = SPR2_MLEL,
		var1 = 0,
		var2 = 0,
		tics = 4,
		nextstate = S_PLAY_STND
}

freeslot("SPR_DSPL", "S_PHOENIXKD")

states[S_PHOENIXKD] = {
	sprite = SPR_DSPL,
	frame = FF_ANIMATE | FF_PAPERSPRITE,
	var1 = 5,
	var2 = 1,
	tics = 10
}



local DoMiniBoost = 1 //TICRATE * 2/12

local DS_ResetVars = function(player, cancel)
 player.ds_electronrush.state = 0
 player.ds_electronrush.timer = 0
 player.ds_electronrush.drifting = 0
 player.ds_electronrush.driftang = 0
 player.ds_electronrush.movespeed = 0
 player.ds_electronrush.isdropdash = false
 player.ds_electronrush.atwall = 0
 player.charability2 = skins[SKIN].ability2

 player.ds_electronrush.delay = (cancel) and cancel or 0
end

local function ChecknBust(mo, sec, spinbust)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    if (fof.flags & FF_STRONGBUST) and (spinbust == true) continue end -- Is it too strong?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

   if (mo.player) and (mo.player.speed < mo.player.runspeed/3) continue end

    EV_CrumbleChain(fof) -- Crumble
  end
end

local DoThokDust = function(player, speed) // From the source code!
	local mo = player.mo
	local prandom = {}
	for i = 0, (leveltime%7) >> 1 // 1, 2, 3 or 4 particles
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_DUST)

		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
			particle.state = S_INVISIBLE
		else
			//particle.state = S_DSDUST_SPAWN
		end

		particle.target = mo
		particle.destscale = (mo.destscale << 1)/4
		P_SetScale(particle, particle.destscale)
		particle.destscale = (mo.destscale << 1)
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-15, 15) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT + prandom[2], mo.scale))
		P_TryMove(particle, particle.x + particle.momx, particle.y + particle.momy, true)
	end
end

local DoDSCRunDust = function(player, speed, spinvar) // From the source code!
	local mo = player.mo
	local prandom = {}
	if leveltime%5 == 0 and (player.speed < player.runspeed/2 or not spinvar) or leveltime%3 == 0 and spinvar and player.speed >= player.runspeed/2
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_DUST)

		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
			particle.state = S_INVISIBLE
		else
			//particle.state = S_DSDUST_SPAWN
		end

		particle.target = mo
		if not spinvar
			particle.destscale = (mo.destscale << 1)/4
			P_SetScale(particle, particle.destscale)
			particle.destscale = (mo.destscale << 1)
		end
		
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-15, 15) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT, mo.scale))
		P_TryMove(particle, particle.x + particle.momx, particle.y + particle.momy, true)
	end
end

local function DoSpinDashDust(player, speed) // From the source code!
	local mo = player.mo
	local prandom = {}
	for i = 0, (leveltime%7) >> 1 // 1, 2, 3 or 4 particles
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)

		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
			particle.state = S_SPINDUST_BUBBLE1
		elseif player.powers[pw_shield] == SH_ELEMENTAL
			particle.state = S_SPINDUST_FIRE1
		end

		particle.target = mo
		particle.destscale = (mo.destscale << 1)/3
		P_SetScale(particle, particle.destscale)
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT + prandom[2], mo.scale))
		P_TryMove(particle, particle.x + particle.momx, particle.y + particle.momy, true)
	end
end





addHook("PreThinkFrame", function()
 for player in players.iterate do
  if player.mo and player.mo.valid and player.mo.skin == SKIN
   if player.ds_electronrush == nil then return end

   if player.ds_electronrush.state == 1 and player.ds_electronrush.drifting ~= 0
    player.ds_electronrush.driftbreak = (player.cmd.forwardmove < 10) and true or nil
    player.ds_electronrush.fakeside = player.cmd.sidemove

    player.cmd.forwardmove = max($, 50)
    //player.cmd.sidemove = $/2
   end
  else
   return
  end
 end
end)

addHook("MobjLineCollide", function(mo, line)
 if (mo and mo.valid)
 and mo.skin == SKIN
 and (mo.player)
 and (line and line.valid)
  mo.player.lastline = line
 end
 return nil
end, MT_PLAYER)

addHook("MobjMoveBlocked", function(mo, mobj, oldline)
 if (mo and mo.valid)
 and mo.skin == SKIN //uncomment this to make it for that specified skin only
 and (mo.player)
 and (mo.z + mo.height < mo.ceilingz
 and mo.z + 15*P_MobjFlip(mo) > mo.floorz)
 and not P_IsObjectOnGround(mo)
 and mo.player.ds_electronrush ~= nil
 local player, p = mo.player, mo.player
 local ER = player.ds_electronrush

   if (mobj and mobj.valid) then return end
  local storedline, storedside = player.lastlinehit, player.lastsidehit
  player.lastlinehit = -1
  player.lastsidehit = -1
  P_SlideMove(mo)
  player.powers[pw_pushing] = 3

  local line = lines[player.lastlinehit] //player.lastline
  local side = sides[player.lastsidehit]

 if (line and line.valid)

  //make sure we aren't touching a thok barrier
  if (line.frontsector) //whichside
   if (line.frontsector.ceilingheight - line.frontsector.floorheight <= 8 * FRACUNIT or line.frontsector.ceilingpic == "F_SKY1") and (mo.z + mo.height/4*P_MobjFlip(mo) > line.frontsector.ceilingheight)
    return
   end
  end
  if (line.backsector) //other side,,,
   if (line.backsector.ceilingheight - line.backsector.floorheight <= 8 * FRACUNIT or line.backsector.ceilingpic == "F_SKY1") and (mo.z + mo.height/4*P_MobjFlip(mo) > line.backsector.ceilingheight)
    return
   end
  end

 local interpx, interpy = P_ClosestPointOnLine(mo.x, mo.y, line)
  local mywallangle = R_PointToAngle2(mo.x, mo.y, interpx, interpy)

  //if player.ds_electronrush.state == 1
   player.ds_electronrush.atwall = 4
   player.ds_electronrush.thiscoolwallangle = mywallangle
   //P_SlideMove(player.mo)
   //player.powers[pw_pushing] = 3


   /*if player.ds_electronrush.atwall >= 4 and not player.ds_electronrush.state and (player.cmd.buttons&BT_JUMP)
   and mo.momz*P_MobjFlip(mo) < FRACUNIT*4
    player.ds_electronrush.state = 1
    player.ds_electronrush.time = 0
    if player.ds_electronrush ~= nil
     player.ds_electronrush.state = 0
     player.ds_electronrush.isdropdash = false
    end
    player.mo.state = S_PLAY_ROLL
    player.pflags = $|PF_JUMPED|PF_THOKKED|PF_STARTJUMP & ~PF_SPINNING
   end*/

   /*if player.ds_electronrush.state == 1
    ChecknBust(mo, mo.subsector.sector)
			P_InstaThrust(mo, mywallangle, -5*FRACUNIT)
     player.ds_electronrush.state = 0
    player.ds_electronrush.time = 0
   end*/
   //end
  else
   player.lastsidehit = storedside
   player.lastlinehit = storedline
  end
 else
  return
 end
end, MT_PLAYER)


addHook("SpinSpecial", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN and player.charability2 == CA2_SPINDASH
  if player.ds_electronrush == nil then return end
  local ER = player.ds_electronrush

  if (player.ds_electronrush.state == 1) then return true end

  //if ER.state <= 2 and ER.state then return true end


  if not P_IsObjectOnGround(player.mo) and not (player.gotflag) and (player.ds_electronrush.state == 0 or player.ds_electronrush.state == 3) and not (player.pflags&PF_THOKKED) and not (player.pflags&PF_JUMPED) //and (player.ds_spindown ~= nil and player.ds_spindown >= 4)
   local ER = player.ds_electronrush

	if (player.powers[pw_carry]) and player.ds_spindown >= 7
	ER.state = 1
    ER.isdropdash = true
   
   ER.timer = 0
	elseif not (player.powers[pw_carry]) and not (player.pflags&PF_SPINDOWN)
   ER.state = 2
   ER.isdropdash = true
   player.pflags = $|PF_THOKKED|PF_JUMPED
   
   ER.timer = 0
   end
   
   //S_StartSound(player.mo, sfx_spndsh)
   return true
  end

  local notashieldability = (SH_PITY|SH_NONE|SH_FIREFLOWER)
  /*if ER.state == 3 and not (P_IsObjectOnGround(player.mo)) and ER.isdropdash and not ER.atwall and not ER.delay and ER.washoldingspin == true
   
   if (player.powers[pw_shield]) and (player.powers[pw_shield]) ~= SH_PITY and (player.powers[pw_shield]) ~= SH_PINK
    if (player.powers[pw_shield] & SH_FORCE)
     player.mo.momz = -P_GetMobjGravity(player.mo) * P_MobjFlip(player.mo)
    end

    if (player.powers[pw_shield] == SH_WHIRLWIND or player.powers[pw_shield] == SH_THUNDERCOIN)
     P_DoJumpShield(player)
    end

    if (player.powers[pw_shield] == SH_ARMAGEDDON)
     P_BlackOw(player)
     player.mo.state = S_PLAY_SUPER_TRANS1
     P_SetObjectMomZ(player.mo, 8*FRACUNIT)
    end
    
    if (player.powers[pw_shield] == SH_ELEMENTAL)
     player.mo.state = S_PLAY_FALL
     P_SetObjectMomZ(player.mo, -FRACUNIT*18)
    end

    player.pflags = $|PF_SHIELDABILITY & ~(PF_SPINNING)
   else
    player.mo.momz = -$ * 4/5
    P_SetObjectMomZ(player.mo, max(player.mo.momz*P_MobjFlip(player.mo), FRACUNIT*8))
    player.mo.state = S_PLAY_FALL
    S_StartSound(player.mo, sfx_s3k45)
   end

   DS_ResetVars(player)
   return true
  end*/

  
  if (P_IsObjectOnGround(player.mo) and not (player.pflags&PF_SPINDOWN) or (player.mo.eflags&MFE_JUSTHITFLOOR)) and not P_PlayerInPain(player) and (player.playerstate == PST_LIVE)
   if (ER.state == 0 or (ER.state == 3 and not ER.delay)) and not (player.pflags&PF_SPINDOWN) and not (player.pflags&PF_SPINNING)
   //print("slash em")
   ER.state = 4
   ER.delay = 3
   player.pflags = $|PF_SPINDOWN & ~PF_SPINNING

   if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
     local pspeed = FixedHypot(player.mo.momx-player.cmomx, player.mo.momy-player.cmomy) //more accurate speed so you can't abuse diagonal thrusts)
    if pspeed <= player.normalspeed + FRACUNIT*9 and not (CBW_Battle)
     P_InstaThrust(player.mo, player.mo.angle, max(player.runspeed/2, pspeed + FRACUNIT*10))
    else
     P_InstaThrust(player.mo, player.mo.angle, max(player.runspeed/2, pspeed))
    end

   if player.speed <= FRACUNIT*2
    P_MovePlayer(player)
   end
   end

   S_StartSound(player.mo, sfx_s3k42)

   player.mo.state = S_PHOENIX_BATMLEE
   player.panim = PA_DASH
   player.powers[pw_strong] = STR_ANIM|STR_PUNCH


   local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.height/2, MT_PINSTASHIELD)
			instashield.target = player.mo
			instashield.scale = player.mo.scale * 8/4
			instashield.fuse = 12
			player.mo.tracer = instashield	
     instashield.state = S_PINSTAWHIP
			if (player.realmo.eflags & MFE_VERTICALFLIP)
				instashield.eflags = $|MFE_VERTICALFLIP
			end
   return true
   end

   if ER.state == 1 then return true end

  if (player.pflags&PF_SPINNING) and not ER.delay and not (player.pflags&PF_SPINDOWN)
   /*if ER.state ~= 3 and player.mo.state ~= S_PLAY_GLIDE //and not (CBW_Battle)
    ER.state = 1
    player.mo.state = S_PLAY_DASH
   else*/
    //if P_IsObjectOnGround(player.mo)
     player.mo.state = (player.speed > player.runspeed) and S_PLAY_RUN or S_PLAY_WALK
    //end
   //end

   player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
   return true
  end

   if ER.state == 4 or (player.mo.state == S_PHOENIX_BATTWIN and P_IsObjectOnGround(player.mo))
   if not (player.pflags&PF_SPINDOWN)
   //print("Slide punt")

    local ang, spd = player.mo.angle, R_PointToDist2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy) //more accurate speed so you can't abuse diagonal thrusts)
    if spd <= player.normalspeed + FRACUNIT*6
     P_InstaThrust(player.mo, ang, max(player.runspeed, spd + FRACUNIT*7))
    else
     P_InstaThrust(player.mo, ang, max(player.runspeed, spd))
    end

   //P_MovePlayer(player)
   player.pflags = $|PF_SPINNING
   player.mo.state = S_PLAY_GLIDE
   player.normalspeed = skins[SKIN].normalspeed
   ER.delay = TICRATE/3

   /*if player.speed <= player.runspeed
    P_SetObjectMomZ(player.mo, FRACUNIT*1)
   end*/

   ER.state = 0
   S_StartSound(player.mo, sfx_zoom)
   /*return true
   ER.state = 1
     player.mo.state = S_PLAY_DASH
     player.charability = skins[SKIN].ability
     player.charability2 = skins[SKIN].ability2*/
     return true
   end
   return true
   end
   return true
  end
 else
  return
 end
end)

addHook("JumpSpecial", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  if player.ds_electronrush == nil then return end
  local ER = player.ds_electronrush


  if player.ds_electronrush.state == 1
   return true
  end

  if ER.state == 4 and player.mo.state ~= S_PHOENIX_BATTWIN and not (player.pflags&PF_JUMPED)
  and not (player.powers[pw_justsprung] or (player.mo.eflags&MFE_SPRUNG))
   P_DoJump(player, true, true)
   player.mo.momz = $ * 12/11
   return true
  end
 else
  return
 end
end)

addHook("PreThinkFrame", function()
 for player in players.iterate
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  if player.ds_electronrush
   local ER = player.ds_electronrush

    ER.washoldingspin = (player.cmd.buttons&BT_SPIN) and true or false

    if player.mo.state == S_PLAY_FALL and P_IsObjectOnGround(player.mo)
     player.mo.state = S_PLAY_STND
    end

   if ER.state == 3 and not (P_IsObjectOnGround(player.mo)) and ER.isdropdash and not ER.atwall
    player.cmd.buttons = $|BT_SPIN
    player.pflags = $|PF_SPINDOWN
   end
  end
  
 end
 end
end)

/*addHook("MobjThinker", function(rollout)
	if rollout and rollout.valid
		if not P_LookForPlayers(rollout, FRACUNIT*30, true, true) then return end
		
		
	else
		return
	end
end, MT_ROLLOUTROCK)*/



addHook("PlayerThink", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  if player.ds_electronrush == nil
   player.ds_electronrush = {}
   
   DS_ResetVars(player)
  end
  
  local ER = player.ds_electronrush

  if player.ds_spindown ~= nil
   player.ds_spindown = ((player.cmd.buttons&BT_SPIN) and ER.washoldingspin) and $ + 1 or 0
  else
   player.ds_spindown = 0
  end


if P_IsObjectOnGround(player.mo) and not player.powers[pw_carry] and player.mo.state ~= S_PLAY_PAIN and player.linearaccel == nil and player.wassloping == nil and player.mo.state ~= S_PLAY_STUN
   if (player.speed > player.normalspeed+FRACUNIT or (player.mo.eflags & MFE_UNDERWATER) and player.speed >= player.runspeed) and player.mo.state ~= S_PLAY_SKID and not player.skidtime
    local thenewfriction = (player.mo.eflags & MFE_UNDERWATER) and max(FRACUNIT * 972/1000, player.mo.friction) or (player.speed > 70*FRACUNIT) and max(FRACUNIT * 990/1000, player.mo.friction) or max(FRACUNIT * 990/1000, player.mo.friction)

    player.mo.friction =  $ + FixedMul(thenewfriction - $, FixedHypot(player.cmd.forwardmove * FRACUNIT, player.cmd.sidemove * FRACUNIT) / 50) 
   end
  end

  player.charflags = $|SF_NOSHIELDABILITY


  if (P_IsObjectOnGround(player.mo)) and not (player.mo.eflags&MFE_TOUCHWATER) and not player.powers[pw_super] and not player.powers[pw_carry]
				if (player.mo.state == S_PLAY_DASH or player.speed > 39*FRACUNIT) and (player.cmd.forwardmove or player.cmd.sidemove) and (ER.state ~= 1)
				and player.speed
         if leveltime%3 == 0
					DoThokDust(player, max(12*FRACUNIT, player.speed))
        end
				elseif player.speed > FRACUNIT
					if (player.pflags&PF_SPINNING)
						if player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_GLIDE
							DoDSCRunDust(player, max(player.speed, 8*FRACUNIT), true)
						end
					elseif player.mo.state == S_PLAY_RUN or player.speed >= player.runspeed or ER.state == 4
						/*if player.mo.state == S_PLAY_WALK
							DoDSCWalkDust(player, player.speed)
						else*/
						DoDSCRunDust(player, player.speed/2)
					end
				end
			end





  if ER.atwall
   ER.atwall = $ - 1
  end

  if ER.delay > 0
   ER.delay = max(0, $-1)
  end
  
  player.mindash = (ER.isdropdash) and 30*FRACUNIT or 45*FRACUNIT
  player.maxdash = (player.gotflag) and 42*FRACUNIT or (CBW_Battle) and 60*FRACUNIT or 69*FRACUNIT
  player.acceleration = 32

  local line, side = lines[player.lastlinehit], sides[player.lastsidehit]


//    Charge states

  if ER.state == 1 // Crouch & Drift State
   if P_PlayerInPain(player) or ((player.mo.eflags & MFE_JUSTHITFLOOR) and (ER.wasonwconveyor or ER.atwall)) or player.playerstate ~= PST_LIVE
    player.charability2 = skins[SKIN].ability2
    DS_ResetVars(player)

    if ER.wasonwconveyor
     P_Thrust(player.mo, player.drawangle, FRACUNIT*15)
     //P_SetObjectMomZ(player.mo, FRACUNIT*5, true)
     player.mo.state = S_PLAY_ROLL
     player.pflags = $|PF_SPINNING & ~PF_THOKKED
    end
    return
   end

    ER.getThisLowdiff = R_PointToAngle2(0,0, player.mo.momx, player.mo.momy) - (player.cmd.angleturn<<16) //(player.cmd.angleturn<<16) - R_PointToAngle2(0,0, player.mo.momx, player.mo.momy) + R_PointToAngle2(0,0, player.cmd.forwardmove*FRACUNIT, -player.cmd.forwardmove*FRACUNIT)
    local usethisangle = ER.getThisLowdiff


    local Sign = function(num)
     local retsign = (num > 0) and 1 or (num < 0) and -1 or 0
     return retsign
    end

    local usethisspeed = 0

    if (ER.oldDiffAng ~= nil) and (abs(ER.oldDiffAng) ~= abs(ER.getThisLowdiff))
     usethisspeed = ER.oldDiffspeed
     usethisangle = ER.oldDiffAng
    end

    usethisangle = min(max(ANG1*25, abs(usethisangle)), ANG1*90) * Sign(usethisangle) //should result in just the sign???

    ER.oldDiffspeed,  ER.oldDiffAng = R_PointToDist2(0,0, P_ReturnThrustX(player.mo, usethisangle, player.speed), P_ReturnThrustY(player.mo, usethisangle, player.speed)), ER.getThisLowdiff
    
   /*if (ER.oldangturn ~= nil) and 
   ER.oldangturn*/


    //print(ER.getThisLowdiff/ANG1)
    //print(usethisangle/ANG1)

   player.charability2 = CA2_NONE
   ER.timer = $ + 1
   if ER.timer*2 == TICRATE*16/3
	S_StartSound(player.mo, sfx_s3ka2)
   end 
   ER.movespeed = max(player.runspeed/2, R_PointToDist2(0, 0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy))
   player.normalspeed = FRACUNIT*5
   player.acceleration = 20
   player.pflags = $ & ~(PF_SPINNING|PF_STARTDASH)

   if player.cmd.sidemove < -5 or player.cmd.sidemove > 5 and not (player.powers[pw_carry])
   P_Thrust(player.mo, R_PointToAngle2(0,0,player.mo.momx-player.cmomx,player.mo.momy-player.cmomy), FRACUNIT/2)
   elseif (player.cmd.forwardmove == 0) and P_IsObjectOnGround(player.mo)
    if usethisspeed ~= 0 and not ((player.cmd.buttons&BT_JUMP) and ER.atwall)
     P_InstaThrust(player.mo, (player.cmd.angleturn<<16) + usethisangle, R_PointToDist2(0, 0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy))
     player.cmd.angleturn = $ + usethisangle>>16
    end
   end

   if P_IsObjectOnGround(player.mo) or player.mo.state == S_PLAY_DASH
    player.pflags = $|PF_STARTDASH
    //if leveltime%4 == 0
    DoSpinDashDust(player, min(70*FRACUNIT, ER.timer*FRACUNIT*2))
    //end
   end

  
  if (ER.atwall > 0 and (player.cmd.buttons&BT_JUMP))
   player.mo.state = S_PLAY_CLING
   player.drawangle = ER.thiscoolwallangle
   ER.isdropdash = true
   
  elseif ER.isdropdash
   player.mo.state = S_PLAY_SPINDASH
   player.drawangle = player.mo.angle
   
  else
   player.mo.state = S_PLAY_DASH
   player.powers[pw_strong] = STR_NONE
   player.drawangle = (player.pflags&PF_ANALOGMODE) and (player.cmd.angleturn<<16) or player.mo.angle
   
   if P_IsObjectOnGround(player.mo)
	player.mo.friction = max(FRACUNIT*981/1000, $)
   end
  end
  
  

   //ER.driftang = (player.pflags&PF_ANALOGMODE) and player.cmd.angleturn<<16 or R_PointToAngle2(0, 0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy)
    local cameraang = player.cmd.angleturn<<16


   if ER.atwall > 0 and ER.isdropdash and (player.cmd.buttons&BT_JUMP)
    P_Thrust(player.mo, ER.thiscoolwallangle, FRACUNIT/2)
    //player.mo.momx = ($-player.cmomx)/2 + player.cmomx
    //player.mo.momy = ($-player.cmomy)/2 + player.cmomy
    P_SetObjectMomZ(player.mo, max(player.mo.momz*P_MobjFlip(player.mo) * 3/4, player.mo.momz*P_MobjFlip(player.mo) - (P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo))/3), false)
    
    if (line and line.valid) and (side and side.valid)

    // Conveyors are SO stupid

			if side == player.lastside
				// H
				if (side.textureoffset != player.cmom or side.rowoffset != player.cmomz)
        local xoff = FixedMul(side.textureoffset-player.cmom, cos(ER.thiscoolwallangle + ANGLE_90))
        local yoff = FixedMul(side.textureoffset-player.cmom, sin(ER.thiscoolwallangle + ANGLE_90))

					P_TryMove(player.mo, player.mo.x + xoff, player.mo.y + yoff, true)
					

					//GO UPPP
					player.mo.z = $ + side.rowoffset - player.cmomz
					player.mo.momz = 0 //$ * 90/100
        ER.wasonwconveyor = 2
				end
			end
     end
   end
   
   
   

   //       Release
   if (not (player.cmd.buttons&BT_SPIN) or (ER.movespeed ~= nil and ER.movespeed < FRACUNIT) or (player.mo.eflags&MFE_JUSTHITFLOOR) and player.ds_electronrush.isdropdash) and not P_PlayerInPain(player) and (player.playerstate == PST_LIVE)

    if ER.movespeed > -FRACUNIT or (player.mo.eflags&MFE_JUSTHITFLOOR)

    if ER.timer > DoMiniBoost or (player.mo.eflags&MFE_JUSTHITFLOOR) or ER.isdropdash//decide to either boost
     //print("boost")

     local thrust = min(player.mindash + (ER.timer*FRACUNIT)/(TICRATE/2), player.maxdash)

     if ER.isdropdash and not (ER.wasonwconveyer and (player.mo.eflags&MFE_JUSTHITFLOOR))
      player.pflags = $|PF_SPINNING|PF_THOKKED|PF_STARTJUMP
      player.mo.state = S_PLAY_ROLL
      S_StartSound(player.mo, sfx_zoom)
	  if not ER.atwall
		P_SetObjectMomZ(player.mo, min((P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo))*15, FRACUNIT*6) * (min(max(8, ER.timer), 13)/7), true)
	  end
	  
   
    //P_SetObjectMomZ(player.mo, P_GetMobjGravity(player.mo)*8, true)
      
      if not P_IsObjectOnGround(player.mo) and not (player.powers[pw_carry])
       player.mo.momz = $ * 4/4
      end

     if ER.atwall > 1 and ER.isdropdash and not (ER.wasonwconveyer and (player.mo.eflags&MFE_JUSTHITFLOOR)) and (player.cmd.buttons&BT_JUMP) and not (player.powers[pw_carry])
      P_Thrust(player.mo, ER.thiscoolwallangle, -FRACUNIT*8)
      P_SetObjectMomZ(player.mo, FRACUNIT*15, false)
      player.pflags = $|PF_THOKKED & ~PF_STARTJUMP
      player.mo.state = S_PLAY_SPRING
      player.powers[pw_justsprung] = 3
      player.drawangle = ER.thiscoolwallangle + ANGLE_180
      ER.isdropdash = false
      ER.timer = TICRATE/4
     end
     else
     if P_IsObjectOnGround(player.mo) or (player.powers[pw_carry])
      player.mo.state = S_PLAY_RUN
      S_StartSound(player.mo, sfx_zoom)
	  
	  for i = -1, 1, 2
				local ang = i * ANG10
				local factor = FixedMul(5*player.mo.scale, cos(ang))
				local x = P_ReturnThrustX(player.mo, player.drawangle + ANGLE_180 + ang, 24*player.mo.scale)
				local y = P_ReturnThrustY(player.mo, player.drawangle + ANGLE_180 + ang, 24*player.mo.scale)
				local dust = P_SpawnMobjFromMobj(player.mo, x, y, 0, MT_THOK)
				if player.mo.eflags & MFE_TOUCHWATER 
					dust.scale = 2*$/3
				else
					dust.scale = 3*$/4
				end
				dust.angle = R_PointToAngle2(dust.x, dust.y, player.mo.x, player.mo.y)
				dust.state = S_PHOENIXKD
				dust.colorized = true
				dust.color = SKINCOLOR_BONE
				
				if (player.mo.eflags&MFE_UNDERWATER)
				dust.frame = $|TR_TRANS30
				else
				dust.frame = $|TR_TRANS20
				end
				
				dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_90))
				dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_90))
			end
     else
      player.mo.state = S_PLAY_ROLL
      S_StartSound(player.mo, sfx_zoom)
     end
      S_StartSound(player.mo, sfx_s3k45)
     end

     
     if (ER.atwall < 3 or (ER.wasonwconveyer and (player.mo.eflags&MFE_JUSTHITFLOOR)) or not (player.cmd.buttons&BT_JUMP)) and not (player.powers[pw_carry])
	 local drawanglebutnot = (player.mo.state == S_PLAY_SKID or player.powers[pw_carry]) and player.mo.angle or player.drawangle
     P_InstaThrust(player.mo, drawanglebutnot, max(thrust, player.speed + FRACUNIT*3)) //trust me, drawangle is better rn
     end

     ER.maxdshspd = max(33*FRACUNIT, FixedHypot(player.mo.momx, player.mo.momy) * 5/7 + ER.timer * FRACUNIT/5)
     ER.spdvalue = player.mindash //+ FRACUNIT*3
     
   if player.speed <= FRACUNIT*2 and not (player.powers[pw_carry])
    P_MovePlayer(player)
   end
     player.charability2 = skins[SKIN].ability2
     ER.state = (ER.atwall < 3 or (ER.wasonwconveyer and (player.mo.eflags&MFE_JUSTHITFLOOR))) and 3 or 3
     ER.timer = (CBW_Battle) and min(TICRATE*12/3, max(18, $ * 3/2)) or min(TICRATE*16/3, max(18, $ * 4/2))
    else //or swing the bat

     //print("slash")

     ER.state = 0
     ER.timer = 0
    end
    
    ER.delay = 9
    ER.drifting = 0
    player.normalspeed = skins[SKIN].normalspeed
    player.acceleration = skins[SKIN].acceleration
    player.charability2 = skins[SKIN].ability2
   else
    DS_ResetVars(player)
    player.normalspeed = skins[SKIN].normalspeed
    player.acceleration = skins[SKIN].acceleration
    player.charability2 = skins[SKIN].ability2
    ER.isdropdash = false
    if P_IsObjectOnGround(player.mo)
     player.mo.state = S_PLAY_SKID
    end
   end
   end
  end
  
  
  
  

 //               IS  Stomp State!


  if ER.state == 2
   ER.timer = $ + 1
    player.charability2 = skins[SKIN].ability2

   if ER.timer >= 11 or (player.mo.eflags&MFE_JUSTHITFLOOR)
    ER.state = 1
    ER.isdropdash = true
    player.pflags = $|PF_THOKKED|PF_SPINNING
    //ER.timer = 0
    //S_StartSound(player.mo, sfx_spndsh)
   elseif not (player.cmd.buttons&BT_SPIN) or (P_IsObjectOnGround(player.mo)) //or ER.timer > 10
    ER.state = 4
    ER.isdropdash = false
   ER.delay = 3
   player.mo.state = S_PHOENIX_BATTWIN
   
   if player.mo.momz*P_MobjFlip(player.mo) > 0 then player.mo.momz = $ * 2/3 end
   if not (player.cmd.buttons&BT_JUMP) or (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
    P_SetObjectMomZ(player.mo, min((P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo))*15, FRACUNIT*6) * (min(max(8, ER.timer), 13)/7), true)
	end
   player.pflags = $|PF_THOKKED & ~PF_SPINNING

   if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0) or (player.cmd.buttons&BT_JUMP)
     local pspeed = FixedHypot(player.mo.momx-player.cmomx, player.mo.momy-player.cmomy) //more accurate speed so you can't abuse diagonal thrusts)

    if pspeed <= player.normalspeed + FRACUNIT*6
     P_InstaThrust(player.mo, player.mo.angle, max(player.runspeed/2, pspeed + FRACUNIT*8))
    else
     P_InstaThrust(player.mo, player.mo.angle, max(player.runspeed/2, pspeed))
    end
   elseif not (player.cmd.buttons&BT_JUMP)
    P_SetObjectMomZ(player.mo, min((P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo))*14, FRACUNIT*6) * (min(max(8, ER.timer), 12)/12), true)
   end

   S_StartSound(player.mo, sfx_s3k42)

   player.mo.state = S_PHOENIX_BATTWIN
   player.mo.state = S_PHOENIX_BATTWIN
   player.mo.frame = $|0 & ~FF_FRAMEMASK
   player.panim = PA_DASH
   player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_BUST|STR_SPRING|STR_SPIKE

   local instashield = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_PINSTASHIELD)
			instashield.target = player.mo
			instashield.scale = player.mo.scale * 5/4
			instashield.fuse = 12
			player.mo.tracer = instashield	
     instashield.flags = $|MF_PAPERCOLLISION
			if (player.realmo.eflags & MFE_VERTICALFLIP)
				instashield.eflags = $|MFE_VERTICALFLIP
			end
			return //gotta do this so it doesn't get cancelled early
   end
  end





//   Actual move states






  if ER.state == 3       // Boost State

   player.charflags = $|SF_RUNONWATER
   if not ER.timer or (player.powers[pw_carry]) or P_PlayerInPain(player) or player.playerstate ~= PST_LIVE
    ER.state = 0
    ER.timer = 0
    player.charability2 = skins[SKIN].ability2
    player.powers[pw_strong] = $ & ~STR_SPIKE
   //player.charflags = $ & ~SF_RUNONWATER
    player.normalspeed = skins[SKIN].normalspeed

    if (player.pflags&PF_SPINNING)
     player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
     player.mo.state = (P_IsObjectOnGround(player.mo)) and S_PLAY_WALK or $
    end
    return
   end


   if not P_IsObjectOnGround(player.mo) 
    P_SetObjectMomZ(player.mo, -(P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo))/9, true)

	if (player.pflags&PF_SPINNING)
    P_SetObjectMomZ(player.mo, -(P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo))/8, true)

    if ER.isdropdash
     local ang, spd = R_PointToAngle2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy), R_PointToDist2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy)
     P_InstaThrust(player.mo, ang, min(spd, ER.maxdshspd))
     P_SpawnThokMobj(player)

     ChecknBust(player.mo, player.mo.subsector.sector)
    end
	end
   elseif (player.pflags&PF_SPINNING)
    if player.speed <= 5*FRACUNIT
      player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
      player.mo.state = S_PLAY_WALK
    end

    if player.speed > ER.maxdshspd + FRACUNIT
    local ang, spd = R_PointToAngle2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy), R_PointToDist2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy)
    P_InstaThrust(player.mo, ang, max(spd * 996/1000, ER.maxdshspd))
    end
   end

   if not ER.isdropdash
    ER.timer = max($-1, 0)
     
   elseif (player.mo.eflags & MFE_JUSTHITFLOOR)
      //print("can this work?")
      player.pflags = $|PF_SPINNING|PF_THOKKED
      player.mo.state = S_PLAY_ROLL
      ER.maxdshspd = $ * 54/42

      local ang, spd = R_PointToAngle2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy), R_PointToDist2(0,0, player.mo.momx - player.cmomx, player.mo.momy - player.cmomy)
      P_InstaThrust(player.mo, ang, max(spd, ER.maxdshspd))
   end



   local thrust = max(player.mindash, player.maxdash - (ER.timer*FRACUNIT)/8 + 5*FRACUNIT/8)

   if (player.pflags&PF_SPINNING)
   player.normalspeed = (player.powers[pw_sneakers] > ER.timer + 3) and skins[SKIN].normalspeed or skins[SKIN].normalspeed * 6/8
	ER.spdvalue = player.normalspeed * 2
	if player.mo.state == S_PLAY_ROLL and (P_IsObjectOnGround(player.mo) or not (player.pflags&PF_JUMPED) or ER.isdropdash)
	P_SpawnThokMobj(player)
	end
   else
   local minspd, maxspd, timeleft = player.mindash, player.maxdash, ER.timer
   if not ER.spdvalue
    ER.spdvalue = minspd
   end

   if P_IsObjectOnGround(player.mo) or (player.powers[pw_carry])
   ER.spdvalue = min(maxspd, max($ + (maxspd-minspd)/DASHTIME + timeleft*FRACUNIT/10/30, minspd))
   end

   player.normalspeed = ((player.powers[pw_sneakers] > ER.timer + 3) or player.powers[pw_super]) and ER.spdvalue*4/6 or ER.spdvalue/2
   player.acceleration = player.powers[pw_super] and 40 or 35
   end
   if player.speed >= player.runspeed
   player.powers[pw_strong] = $|STR_SPIKE
   else
    player.powers[pw_strong] = $ & ~STR_SPIKE
   end

   player.powers[pw_sneakers] = max(ER.timer, $)
  end



  if P_IsObjectOnGround(player.mo) or ((player.mo.eflags&MFE_SPRUNG) and player.mo.state == S_PLAY_SPRING) or player.powers[pw_carry]
    ER.isdropdash = false //delay it till after thinker
    player.canelectronrush = false
  end
  
  local Value = 6 //spin control strength

			if (player.pflags & PF_SPINNING) and not (player.pflags & PF_JUMPED) and not (player.pflags&PF_STARTDASH) and not (player.pflags&PF_THOKKED)
			and (player.mo.state == S_PLAY_ROLL or player.panim == PA_ROLL or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_GLIDE) //and player.mo.skin ~= "adventuresonic" then //we are ROLLING
				if not player.StoredThing then //make sure we do this first
					player.StoredThing = player.thrustfactor //store the original thrustfactor
				end
				
				if not P_IsObjectOnGround(player.mo) then //midair?
					Value = $/4
				end
				
				player.thrustfactor = (skins[SKIN].thrustfactor)*Value //factor our thrust factor, we want it STRONG
				player.wasrolling = true //we spinning
			elseif player.StoredThing then //we aren't rolling, but the thing exists?
				player.thrustfactor = player.StoredThing //restore our thrust factor
				player.StoredThing = nil //delete this.
			end




  if ER.state == 4 // Slash State
   player.acceleration = 19

   player.charability = CA_TWINSPIN

   if player.mo.state == S_PHOENIX_BATTWIN and not P_IsObjectOnGround(player.mo)
    player.charability2 = CA2_MELEE
    player.pflags = $|PF_SPINDOWN
    player.cmd.buttons = $|BT_SPIN

   elseif P_IsObjectOnGround(player.mo)
    player.charability2 = skins[SKIN].ability2

    player.mo.friction = FRACUNIT * 98/100
    player.normalspeed = FRACUNIT*30

   //player.drawangle = (player.pflags&PF_ANALOGMODE) and (player.cmd.angleturn<<16) or player.mo.angle
    //if player.speed > 5*FRACUNIT then player.pflags = $|PF_STARTDASH end
   end

   if player.mo.state == S_PHOENIX_BATMLEE or player.mo.state == S_PHOENIX_BATTWIN or (player.mo.eflags&MFE_JUSTHITFLOOR)

    player.powers[pw_strong] = (player.mo.state == S_PHOENIX_BATTWIN) and STR_ANIM|STR_PUNCH|STR_SPIKE|STR_BUST|STR_SPRING or STR_ANIM|STR_PUNCH|STR_SPIKE|STR_WALL
    //ChecknBust(player.mo, player.mo.subsector.sector)

    player.panim = PA_DASH


	
	if ((player.mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo) and (player.mo.state == S_PHOENIX_BATTWIN)) and (player.cmd.buttons&BT_SPIN)
		player.mo.state = S_PLAY_ROLL
   player.pflags = $|PF_SPINNING
   ER.state = 0
	 player.normalspeed = skins[SKIN].normalspeed
	 ER.delay = TICRATE/3
     player.charability = skins[SKIN].ability
     player.charability2 = skins[SKIN].ability2
	   S_StartSound(player.mo, sfx_spin)
	   return
	end

	
	/*if (player.mo.state == S_PHOENIX_BATTWIN) and (P_IsObjectOnGround(player.mo)) and (player.cmd.buttons&BT_SPIN)
		player.pflags = $|PF_SPINNING|PF_THOKKED
      player.mo.state = S_PLAY_ROLL
      S_StartSound(player.mo, sfx_zoom)
	  ER.isdropdash = true
	  
     ER.maxdshspd = max(33*FRACUNIT, FixedHypot(player.mo.momx, player.mo.momy) * 5/7 + ER.timer * FRACUNIT/5)
     ER.spdvalue = player.mindash //+ FRACUNIT*3
     
   if player.speed <= FRACUNIT*2
    P_MovePlayer(player)
   end
   
     player.charability2 = skins[SKIN].ability2
     ER.state = (ER.atwall < 3 or (ER.wasonwconveyer and (player.mo.eflags&MFE_JUSTHITFLOOR))) and 3 or 3
     ER.timer = (CBW_Battle) and min(TICRATE*16/3, max(18, $ * 3/2)) or min(TICRATE*21/3, max(18, $ * 3/2))
	end*/
   elseif player.mo.state == S_PHOENIX_BATMLEL or player.mo.state == S_PLAY_MELEE_LANDING or (player.mo.eflags&MFE_JUSTHITFLOOR) or player.mo.state == S_PLAY_ROLL

    player.powers[pw_strong] = STR_ANIM|STR_PUNCH|STR_SPIKE
    //ChecknBust(player.mo, player.mo.subsector.sector)
    player.mo.friction = FRACUNIT * 961/990
    player.normalspeed = skins[SKIN].normalspeed
     

    if (player.cmd.buttons & BT_SPIN) and P_IsObjectOnGround(player.mo) and (player.mo.tics <= 4 and player.mo.state == S_PHOENIX_BATMLEL)
     ER.state = (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PHOENIX_BATTWIN) and 0 or 1
     player.mo.state = S_PLAY_DASH
	 player.normalspeed = skins[SKIN].normalspeed
	 ER.delay = TICRATE/3
     player.charability = skins[SKIN].ability
     player.charability2 = skins[SKIN].ability2
     return true
	elseif player.mo.state == S_PLAY_ROLL and P_IsObjectOnGround(player.mo)
	 player.mo.state = S_PLAY_WALK
    end
   else
    if (not P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR)) and ER.delay
     player.mo.state = S_PHOENIX_BATTWIN
     player.mo.frame = 0 & ~FF_FRAMEMASK
     player.mo.state = S_PHOENIX_BATTWIN
     player.panim = PA_DASH
    else
    ER.state = 0
    player.charability = skins[SKIN].ability
   player.charability2 = skins[SKIN].ability2
    player.powers[pw_strong] = STR_NONE
    player.normalspeed = skins[SKIN].normalspeed
    end
    return
   end
  end
  
  if ((player.mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) and (player.mo.state == S_PHOENIX_BATTWIN) and (player.cmd.buttons&BT_SPIN)
		player.mo.state = S_PLAY_ROLL
   player.pflags = $|PF_SPINNING
   ER.state = 0
	 player.normalspeed = skins[SKIN].normalspeed
	 ER.delay = TICRATE/3
     player.charability = skins[SKIN].ability
     player.charability2 = skins[SKIN].ability2
	   S_StartSound(player.mo, sfx_spin)
	   return
	end

   if player.mo.tracer and player.mo.tracer.valid and player.mo.tracer.type == MT_PINSTASHIELD
    local insta = player.mo.tracer

    if P_IsObjectOnGround(player.mo) and player.mo.state ~= S_PHOENIX_BATTWIN
     //P_MoveOrigin(insta, player.mo.x, player.mo.y, player.mo.z + player.mo.height/2)
    end

    if insta.state >= S_PINSTAWHIP and player.mo.state == S_PLAY_JUMP
     insta.state = S_PINSTASHIELD1B
     insta.scale = player.mo.scale * 5/4
			insta.fuse = 12	
     insta.flags = $|MF_PAPERCOLLISION
     insta.frame = $|FF_HORIZONTALFLIP
     insta.flipit = true
    end
    //if insta.state < S_PINSTAWHIP
      local ghost = P_SpawnGhostMobj(insta)
      ghost.fuse = 6
      ghost.color = player.skincolor
      ghost.colorized = true
    //end
   end


  ER.wasonwconveyor = ($ ~= nil) and max($-1,0) or 0

  if (line and line.valid) and (side and side.valid) //always reset these last so that they stay accurate
   player.cmom = side.textureoffset
   player.cmomz = side.rowoffset
   player.lastside = side
  end
 else
  return
 end
end)

addHook("JumpSpinSpecial", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  if player.ds_spindown > TICRATE/9 or player.ds_spindown < 1 or (player.ds_electronrush ~= nil and player.ds_electronrush.state and player.ds_electronrush.state == 1) then return end

  if player.ds_electronrush ~= nil and (player.ds_electronrush.state == 0 or player.ds_electronrush.state == 3) and (player.canelectronrush or not (player.pflags&PF_THOKKED)) //and not (player.pflags&PF_SPINDOWN)
   local ER = player.ds_electronrush

   ER.state = 2
   ER.isdropdash = true
    player.canelectronrush = false
   player.pflags = $|PF_THOKKED
   ER.timer = 0
   //S_StartSound(player.mo, sfx_spndsh)
   return true
  end
 else
  return
 end
end)